"use strict";var _arcLength=require("./arc-length.js");describe("The arc length",(function(){it("should be zero when the radius and angle are not provided",(function(){expect((0,_arcLength.arcLengthDeg)()).toBe(0);expect((0,_arcLength.arcLengthRad)()).toBe(0)}));it("should be correctly calculated for positive inputs",(function(){expect((0,_arcLength.arcLengthDeg)(20,0)).toBe(0);expect((0,_arcLength.arcLengthDeg)(20,90)).toBe(31.41592653589793);expect((0,_arcLength.arcLengthDeg)(20,360)).toBe(125.66370614359172);expect((0,_arcLength.arcLengthDeg)(20,450.617)).toBe(157.29500630918577);expect((0,_arcLength.arcLengthDeg)(0,90)).toBe(0);expect((0,_arcLength.arcLengthDeg)(45.34,90)).toBe(71.21990545688061);expect((0,_arcLength.arcLengthDeg)(100,90)).toBe(157.07963267948966);expect((0,_arcLength.arcLengthDeg)(890.67,90)).toBe(1399.0611643864104);expect((0,_arcLength.arcLengthRad)(20,0)).toBe(0);expect((0,_arcLength.arcLengthRad)(20,90)).toBe(1800);expect((0,_arcLength.arcLengthRad)(20,360)).toBe(7200);expect((0,_arcLength.arcLengthRad)(20,450.617)).toBe(9012.34);expect((0,_arcLength.arcLengthRad)(0,90)).toBe(0);expect((0,_arcLength.arcLengthRad)(45.34,90)).toBe(4080.6000000000004);expect((0,_arcLength.arcLengthRad)(100,90)).toBe(9e3);expect((0,_arcLength.arcLengthRad)(890.67,90)).toBe(80160.3)}));it("should be negative for negative inputs",(function(){expect((0,_arcLength.arcLengthDeg)(20,-90)).toBe(-31.41592653589793);expect((0,_arcLength.arcLengthDeg)(20,-360)).toBe(-125.66370614359172);expect((0,_arcLength.arcLengthDeg)(20,-450.617)).toBe(-157.29500630918577);expect((0,_arcLength.arcLengthDeg)(-20,90)).toBe(-31.41592653589793);expect((0,_arcLength.arcLengthDeg)(-45.34,90)).toBe(-71.21990545688061);expect((0,_arcLength.arcLengthDeg)(-100,90)).toBe(-157.07963267948966);expect((0,_arcLength.arcLengthDeg)(-890.67,90)).toBe(-1399.0611643864104);expect((0,_arcLength.arcLengthRad)(20,-90)).toBe(-1800);expect((0,_arcLength.arcLengthRad)(20,-360)).toBe(-7200);expect((0,_arcLength.arcLengthRad)(20,-450.617)).toBe(-9012.34);expect((0,_arcLength.arcLengthRad)(-20,90)).toBe(-1800);expect((0,_arcLength.arcLengthRad)(-45.34,90)).toBe(-4080.6000000000004);expect((0,_arcLength.arcLengthRad)(-100,90)).toBe(-9e3);expect((0,_arcLength.arcLengthRad)(-890.67,90)).toBe(-80160.3)}));it("should not be properly defined for incorrect inputs",(function(){expect((0,_arcLength.arcLengthDeg)(20,NaN)).toBeNaN();expect((0,_arcLength.arcLengthDeg)(NaN,NaN)).toBeNaN();expect((0,_arcLength.arcLengthDeg)(NaN,20)).toBeNaN();expect((0,_arcLength.arcLengthDeg)(20,null)).toBe(0);expect((0,_arcLength.arcLengthDeg)(null,null)).toBe(0);expect((0,_arcLength.arcLengthDeg)(null,20)).toBe(0);expect((0,_arcLength.arcLengthRad)(20,NaN)).toBeNaN();expect((0,_arcLength.arcLengthRad)(NaN,NaN)).toBeNaN();expect((0,_arcLength.arcLengthRad)(NaN,20)).toBeNaN();expect((0,_arcLength.arcLengthRad)(20,null)).toBe(0);expect((0,_arcLength.arcLengthRad)(null,null)).toBe(0);expect((0,_arcLength.arcLengthRad)(null,20)).toBe(0)}))}));describe("The arc length, when calculated from degrees,",(function(){it("should not clamp the angle between 0 and 360 degrees",(function(){expect((0,_arcLength.arcLengthDeg)(20,-90)).toBe(-31.41592653589793);expect((0,_arcLength.arcLengthDeg)(20,-180)).toBe(-62.83185307179586);expect((0,_arcLength.arcLengthDeg)(20,450.617)).toBe(157.29500630918577);expect((0,_arcLength.arcLengthDeg)(20,540)).toBe(188.49555921538757)}))}));