"use strict";var _datetimeEnums=require("../datetime-enums");var _beforeAfter=require("./before-after");describe("test before util",(function(){it("FDT_TC_124 - basic operation runs",(function(){var durationObj={Unit:_datetimeEnums.DatetimeUnits.Day.name,number:2,ms:_datetimeEnums.DatetimeUnits.Day.ms*2},timestamp=+new Date(2018,1,8,8,47,3,0);expect((0,_beforeAfter.before)(durationObj,timestamp)).toEqual(+new Date(2018,1,6,8,47,3))}));it("FDT_TC_125 - missing duration should throw error",(function(){expect((function(){(0,_beforeAfter.before)()})).toThrowError(Error,"duration is missing")}));it("FDT_TC_126 - missing date should use current",(function(){var durationObj={Unit:_datetimeEnums.DatetimeUnits.Hour.name,number:3,ms:_datetimeEnums.DatetimeUnits.Hour.ms*3},timestamp=+new Date;expect((0,_beforeAfter.before)(durationObj,timestamp)).toEqual(timestamp-durationObj.ms)}));it("FDT_TC_127 - incorrect timestamp should throw error",(function(){var durationObj={Unit:_datetimeEnums.DatetimeUnits.Hour.name,number:3,ms:_datetimeEnums.DatetimeUnits.Hour.ms*3},timestamp1=-0x335769111f61200,timestamp2="wrong";expect((function(){(0,_beforeAfter.before)(durationObj,timestamp1)})).toThrowError(Error,"timestamp is incorrect");expect((function(){(0,_beforeAfter.before)(durationObj,timestamp2)})).toThrowError(Error,"timestamp is incorrect")}));it("FDT_TC_128 - 1 year before",(function(){var durationObj={Unit:_datetimeEnums.DatetimeUnits.Year.name,number:1,ms:_datetimeEnums.DatetimeUnits.Year.ms*1},timestamp=+new Date(2018,1,8,8,47,3,0);expect((0,_beforeAfter.before)(durationObj,timestamp)).toEqual(+new Date(2017,1,8,8,47,3,0))}));it("FDT_TC_128 - 3 years before",(function(){var durationObj={Unit:_datetimeEnums.DatetimeUnits.Year.name,number:3,ms:_datetimeEnums.DatetimeUnits.Year.ms*3},timestamp=+new Date(2018,1,8,8,47,3,0);expect((0,_beforeAfter.before)(durationObj,timestamp)).toEqual(+new Date(2015,1,8,8,47,3,0))}));it("FDT_TC_128 - 1 quarter before",(function(){var durationObj={Unit:_datetimeEnums.DatetimeUnits.Quarter.name,number:1,ms:_datetimeEnums.DatetimeUnits.Quarter.ms*1},timestamp=+new Date(2018,1,8,8,47,3,0);expect((0,_beforeAfter.before)(durationObj,timestamp)).toEqual(+new Date(2017,10,8,8,47,3,0))}));it("FDT_TC_128 - 3 quarters before",(function(){var durationObj={Unit:_datetimeEnums.DatetimeUnits.Quarter.name,number:3,ms:_datetimeEnums.DatetimeUnits.Quarter.ms*3},timestamp=+new Date(2018,1,8,8,47,3,0);expect((0,_beforeAfter.before)(durationObj,timestamp)).toEqual(+new Date(2017,4,8,8,47,3,0))}));it("FDT_TC_128 - 1 month before",(function(){var durationObj={Unit:_datetimeEnums.DatetimeUnits.Month.name,number:1,ms:_datetimeEnums.DatetimeUnits.Month.ms*1},timestamp=+new Date(2018,1,8,8,47,3,0);expect((0,_beforeAfter.before)(durationObj,timestamp)).toEqual(+new Date(2018,0,8,8,47,3,0))}));it("FDT_TC_128 - 5 months before",(function(){var durationObj={Unit:_datetimeEnums.DatetimeUnits.Month.name,number:5,ms:_datetimeEnums.DatetimeUnits.Month.ms*5},timestamp=+new Date(2018,1,8,8,47,3,0);expect((0,_beforeAfter.before)(durationObj,timestamp)).toEqual(+new Date(2017,8,8,8,47,3,0))}));it("FDT_TC_128 - 1 week before",(function(){var durationObj={Unit:_datetimeEnums.DatetimeUnits.Week.name,number:1,ms:_datetimeEnums.DatetimeUnits.Week.ms*1},timestamp=+new Date(2018,1,8,8,47,3,0);expect((0,_beforeAfter.before)(durationObj,timestamp)).toEqual(+new Date(2018,1,1,8,47,3,0))}));it("FDT_TC_128 - 2 weeks before",(function(){var durationObj={Unit:_datetimeEnums.DatetimeUnits.Week.name,number:2,ms:_datetimeEnums.DatetimeUnits.Week.ms*2},timestamp=+new Date(2018,1,8,8,47,3,0);expect((0,_beforeAfter.before)(durationObj,timestamp)).toEqual(+new Date(2018,0,25,8,47,3,0))}));it("FDT_TC_128 - 1 day before",(function(){var durationObj={Unit:_datetimeEnums.DatetimeUnits.Day.name,number:1,ms:_datetimeEnums.DatetimeUnits.Day*1},timestamp=+new Date(2018,1,8,8,47,3,0);expect((0,_beforeAfter.before)(durationObj,timestamp)).toEqual(+new Date(2018,1,7,8,47,3,0))}));it("FDT_TC_128 - 20 days before",(function(){var durationObj={Unit:_datetimeEnums.DatetimeUnits.Day.name,number:20,ms:_datetimeEnums.DatetimeUnits.Day*20},timestamp=+new Date(2018,1,8,8,47,3,0);expect((0,_beforeAfter.before)(durationObj,timestamp)).toEqual(+new Date(2018,0,19,8,47,3,0))}));it("FDT_TC_128 - 1 hour before",(function(){var durationObj={Unit:_datetimeEnums.DatetimeUnits.Hour.name,number:1,ms:_datetimeEnums.DatetimeUnits.Hour.ms*1},timestamp=+new Date(2018,1,8,8,47,3,0);expect((0,_beforeAfter.before)(durationObj,timestamp)).toEqual(+new Date(2018,1,8,7,47,3,0))}));it("FDT_TC_128 - 3 hours before",(function(){var durationObj={Unit:_datetimeEnums.DatetimeUnits.Hour.name,number:3,ms:_datetimeEnums.DatetimeUnits.Hour.ms*3},timestamp=+new Date(2018,1,8,8,47,3,0);expect((0,_beforeAfter.before)(durationObj,timestamp)).toEqual(+new Date(2018,1,8,5,47,3,0))}));it("FDT_TC_128 - 1 minute before",(function(){var durationObj={Unit:_datetimeEnums.DatetimeUnits.Minute.name,number:1,ms:_datetimeEnums.DatetimeUnits.Minute*1},timestamp=+new Date(2018,1,8,8,47,3,0);expect((0,_beforeAfter.before)(durationObj,timestamp)).toEqual(+new Date(2018,1,8,8,46,3,0))}));it("FDT_TC_128 - 50 minutes before",(function(){var durationObj={Unit:_datetimeEnums.DatetimeUnits.Minute.name,number:50,ms:_datetimeEnums.DatetimeUnits.Minute*50},timestamp=+new Date(2018,1,8,8,47,3,0);expect((0,_beforeAfter.before)(durationObj,timestamp)).toEqual(+new Date(2018,1,8,7,57,3,0))}));it("FDT_TC_128 - 1 second before",(function(){var durationObj={Unit:_datetimeEnums.DatetimeUnits.Second.name,number:1,ms:_datetimeEnums.DatetimeUnits.Second.ms*1},timestamp=+new Date(2018,1,8,8,47,3,0);expect((0,_beforeAfter.before)(durationObj,timestamp)).toEqual(+new Date(2018,1,8,8,47,2,0))}));it("FDT_TC_128 - 70 seconds before",(function(){var durationObj={Unit:_datetimeEnums.DatetimeUnits.Second.name,number:70,ms:_datetimeEnums.DatetimeUnits.Second.ms*70},timestamp=+new Date(2018,1,8,8,47,3,0);expect((0,_beforeAfter.before)(durationObj,timestamp)).toEqual(+new Date(2018,1,8,8,45,53,0))}));it("FDT_TC_128 - 1 ms before",(function(){var durationObj={Unit:_datetimeEnums.DatetimeUnits.Millisecond.name,number:1,ms:_datetimeEnums.DatetimeUnits.Millisecond.ms*1},timestamp=+new Date(2018,1,8,8,47,3,0);expect((0,_beforeAfter.before)(durationObj,timestamp)).toEqual(+new Date(2018,1,8,8,47,2,999))}));it("FDT_TC_128 - 10000 ms before",(function(){var durationObj={Unit:_datetimeEnums.DatetimeUnits.Millisecond.name,number:1e4,ms:_datetimeEnums.DatetimeUnits.Millisecond.ms*1e4},timestamp=+new Date(2018,1,8,8,47,3,0);expect((0,_beforeAfter.before)(durationObj,timestamp)).toEqual(+new Date(2018,1,8,8,46,53,0))}))}));describe("test after util",(function(){it("FDT_TC_124 - basic operation runs",(function(){var durationObj={Unit:_datetimeEnums.DatetimeUnits.Day.name,number:2,ms:_datetimeEnums.DatetimeUnits.Day.ms*2},timestamp=+new Date(2018,1,8,8,47,3,0);expect((0,_beforeAfter.after)(durationObj,timestamp)).toEqual(+new Date(2018,1,10,8,47,3))}));it("FDT_TC_125 - missing duration should throw error",(function(){expect((function(){(0,_beforeAfter.after)()})).toThrowError(Error,"duration is missing")}));it("FDT_TC_126 - missing date should use current",(function(){var durationObj={Unit:_datetimeEnums.DatetimeUnits.Hour.name,number:3,ms:_datetimeEnums.DatetimeUnits.Hour.ms*3},timestamp=+new Date;expect((0,_beforeAfter.after)(durationObj,timestamp)).toEqual(timestamp+durationObj.ms)}));it("FDT_TC_127 - incorrect timestamp should throw error",(function(){var durationObj={Unit:_datetimeEnums.DatetimeUnits.Hour.name,number:3,ms:_datetimeEnums.DatetimeUnits.Hour.ms*3},timestamp1=-0x335769111f61200,timestamp2="wrong";expect((function(){(0,_beforeAfter.after)(durationObj,timestamp1)})).toThrowError(Error,"timestamp is incorrect");expect((function(){(0,_beforeAfter.after)(durationObj,timestamp2)})).toThrowError(Error,"timestamp is incorrect")}));it("FDT_TC_128 - 1 year after",(function(){var durationObj={Unit:_datetimeEnums.DatetimeUnits.Year.name,number:1,ms:_datetimeEnums.DatetimeUnits.Year.ms*1},timestamp=+new Date(2018,1,8,8,47,3,0);expect((0,_beforeAfter.after)(durationObj,timestamp)).toEqual(+new Date(2019,1,8,8,47,3,0))}));it("FDT_TC_128 - 3 years after",(function(){var durationObj={Unit:_datetimeEnums.DatetimeUnits.Year.name,number:3,ms:_datetimeEnums.DatetimeUnits.Year.ms*3},timestamp=+new Date(2018,1,8,8,47,3,0);expect((0,_beforeAfter.after)(durationObj,timestamp)).toEqual(+new Date(2021,1,8,8,47,3,0))}));it("FDT_TC_128 - 1 quarter after",(function(){var durationObj={Unit:_datetimeEnums.DatetimeUnits.Quarter.name,number:1,ms:_datetimeEnums.DatetimeUnits.Quarter.ms*1},timestamp=+new Date(2018,1,8,8,47,3,0);expect((0,_beforeAfter.after)(durationObj,timestamp)).toEqual(+new Date(2018,4,8,8,47,3,0))}));it("FDT_TC_128 - 3 quarters after",(function(){var durationObj={Unit:_datetimeEnums.DatetimeUnits.Quarter.name,number:3,ms:_datetimeEnums.DatetimeUnits.Quarter.ms*3},timestamp=+new Date(2018,1,8,8,47,3,0);expect((0,_beforeAfter.after)(durationObj,timestamp)).toEqual(+new Date(2018,10,8,8,47,3,0))}));it("FDT_TC_128 - 1 month after",(function(){var durationObj={Unit:_datetimeEnums.DatetimeUnits.Month.name,number:1,ms:_datetimeEnums.DatetimeUnits.Month.ms*1},timestamp=+new Date(2018,1,8,8,47,3,0);expect((0,_beforeAfter.after)(durationObj,timestamp)).toEqual(+new Date(2018,2,8,8,47,3,0))}));it("FDT_TC_128 - 5 months after",(function(){var durationObj={Unit:_datetimeEnums.DatetimeUnits.Month.name,number:5,ms:_datetimeEnums.DatetimeUnits.Month.ms*5},timestamp=+new Date(2018,1,8,8,47,3,0);expect((0,_beforeAfter.after)(durationObj,timestamp)).toEqual(+new Date(2018,6,8,8,47,3,0))}));it("FDT_TC_128 - 1 week after",(function(){var durationObj={Unit:_datetimeEnums.DatetimeUnits.Week.name,number:1,ms:_datetimeEnums.DatetimeUnits.Week.ms*1},timestamp=+new Date(2018,1,15,8,47,3,0);expect((0,_beforeAfter.after)(durationObj,timestamp)).toEqual(+new Date(2018,1,22,8,47,3,0))}));it("FDT_TC_128 - 2 weeks after",(function(){var durationObj={Unit:_datetimeEnums.DatetimeUnits.Week.name,number:2,ms:_datetimeEnums.DatetimeUnits.Week.ms*2},timestamp=+new Date(2018,1,15,8,47,3,0);expect((0,_beforeAfter.after)(durationObj,timestamp)).toEqual(+new Date(2018,2,1,8,47,3,0))}));it("FDT_TC_128 - 1 day after",(function(){var durationObj={Unit:_datetimeEnums.DatetimeUnits.Day.name,number:1,ms:_datetimeEnums.DatetimeUnits.Day*1},timestamp=+new Date(2016,1,28,8,47,3,0);expect((0,_beforeAfter.after)(durationObj,timestamp)).toEqual(+new Date(2016,1,29,8,47,3,0))}));it("FDT_TC_128 - 20 days after",(function(){var durationObj={Unit:_datetimeEnums.DatetimeUnits.Day.name,number:20,ms:_datetimeEnums.DatetimeUnits.Day*20},timestamp=+new Date(2016,1,28,8,47,3,0);expect((0,_beforeAfter.after)(durationObj,timestamp)).toEqual(+new Date(2016,2,19,8,47,3,0))}));it("FDT_TC_128 - 1 hour after",(function(){var durationObj={Unit:_datetimeEnums.DatetimeUnits.Hour.name,number:1,ms:_datetimeEnums.DatetimeUnits.Hour.ms*1},timestamp=+new Date(2018,1,8,8,57,3,0);expect((0,_beforeAfter.after)(durationObj,timestamp)).toEqual(+new Date(2018,1,8,9,57,3,0))}));it("FDT_TC_128 - 3 hours after",(function(){var durationObj={Unit:_datetimeEnums.DatetimeUnits.Hour.name,number:3,ms:_datetimeEnums.DatetimeUnits.Hour.ms*3},timestamp=+new Date(2018,1,8,8,57,3,0);expect((0,_beforeAfter.after)(durationObj,timestamp)).toEqual(+new Date(2018,1,8,11,57,3,0))}));it("FDT_TC_128 - 1 minute after",(function(){var durationObj={Unit:_datetimeEnums.DatetimeUnits.Minute.name,number:1,ms:_datetimeEnums.DatetimeUnits.Minute*1},timestamp=+new Date(2018,1,8,8,47,3,0);expect((0,_beforeAfter.after)(durationObj,timestamp)).toEqual(+new Date(2018,1,8,8,48,3,0))}));it("FDT_TC_128 - 50 minutes after",(function(){var durationObj={Unit:_datetimeEnums.DatetimeUnits.Minute.name,number:50,ms:_datetimeEnums.DatetimeUnits.Minute*50},timestamp=+new Date(2018,1,8,8,47,3,0);expect((0,_beforeAfter.after)(durationObj,timestamp)).toEqual(+new Date(2018,1,8,9,37,3,0))}));it("FDT_TC_128 - 1 second after",(function(){var durationObj={Unit:_datetimeEnums.DatetimeUnits.Second.name,number:1,ms:_datetimeEnums.DatetimeUnits.Second.ms*1},timestamp=+new Date(2018,1,8,8,47,3,0);expect((0,_beforeAfter.after)(durationObj,timestamp)).toEqual(+new Date(2018,1,8,8,47,4,0))}));it("FDT_TC_128 - 70 seconds after",(function(){var durationObj={Unit:_datetimeEnums.DatetimeUnits.Second.name,number:70,ms:_datetimeEnums.DatetimeUnits.Second.ms*70},timestamp=+new Date(2018,1,8,8,47,3,0);expect((0,_beforeAfter.after)(durationObj,timestamp)).toEqual(+new Date(2018,1,8,8,48,13,0))}));it("FDT_TC_128 - 1 ms after",(function(){var durationObj={Unit:_datetimeEnums.DatetimeUnits.Millisecond.name,number:1,ms:_datetimeEnums.DatetimeUnits.Millisecond.ms*1},timestamp=+new Date(2018,1,8,8,47,3,0);expect((0,_beforeAfter.after)(durationObj,timestamp)).toEqual(+new Date(2018,1,8,8,47,3,1))}));it("FDT_TC_128 - 10000 ms after",(function(){var durationObj={Unit:_datetimeEnums.DatetimeUnits.Millisecond.name,number:1e4,ms:_datetimeEnums.DatetimeUnits.Millisecond.ms*1e4},timestamp=+new Date(2018,1,8,8,47,3,0);expect((0,_beforeAfter.after)(durationObj,timestamp)).toEqual(+new Date(2018,1,8,8,47,13,0))}))}));