"use strict";var _interval=require("./interval");var _datetimeEnums=require("../datetime-enums");describe("interval generator function",(function(){var timestamp=Date.UTC(2018,2,15,11,30,55,23);it("generate 1 week interval without explicit weekStartsFrom value",(function(){var timeDuration={Unit:_datetimeEnums.DatetimeUnits.Week.name,number:1,ms:_datetimeEnums.DatetimeUnits.Week.ms*1},intervalConfig={duration:timeDuration,enableUTC:true},calculatedInterval=(0,_interval.interval)(timestamp,intervalConfig,true);expect(calculatedInterval.start).toEqual(Date.UTC(2018,2,11,0,0,0));expect(calculatedInterval.end).toEqual(Date.UTC(2018,2,18,0,0,0))}));it("generate 2 week interval with given weekStartsFrom value",(function(){var timeDuration={Unit:_datetimeEnums.DatetimeUnits.Week.name,number:2,ms:_datetimeEnums.DatetimeUnits.Week.ms*2},intervalConfig={duration:timeDuration,enableUTC:true,weekStartFrom:_datetimeEnums.Weekdays.Tuesday},calculatedInterval=(0,_interval.interval)(timestamp,intervalConfig,true);expect(calculatedInterval.start).toEqual(Date.UTC(2018,2,13,0,0,0));expect(calculatedInterval.end).toEqual(Date.UTC(2018,2,27,0,0,0))}));xit("FDT_TC_120 - missing timestamp should throw error",(function(){var timeDuration={Unit:_datetimeEnums.DatetimeUnits.Quarter.name,number:1,ms:_datetimeEnums.DatetimeUnits.Quarter.ms*1},intervalConfig={duration:timeDuration,enableUTC:true};expect((function(){(0,_interval.interval)(intervalConfig)})).toThrow()}));xit("FDT_TC_120 - missing timestamp with interval config should use current date",(function(){var timeDuration={Unit:_datetimeEnums.DatetimeUnits.Quarter.name,number:1,ms:_datetimeEnums.DatetimeUnits.Quarter.ms*1},intervalConfig={duration:timeDuration,enableUTC:true},currentTimestamp=+new Date,calculatedInterval=(0,_interval.interval)(undefined,intervalConfig);expect(calculatedInterval.start).toBe(currentTimestamp)}));xit("FDT_TC_121 - missing timestamp and interval config should throw error",(function(){expect((function(){(0,_interval.interval)()})).toThrow()}));xit("FDT_TC_122 - missing duration should throw error",(function(){expect((function(){(0,_interval.interval)(timestamp)})).toThrow()}));it("FDT_TC_123 - test interval of 1 year",(function(){var timeDuration={Unit:_datetimeEnums.DatetimeUnits.Year.name,number:1,ms:_datetimeEnums.DatetimeUnits.Year.ms*1},intervalConfig={duration:timeDuration,enableUTC:true},calculatedInterval=(0,_interval.interval)(timestamp,intervalConfig,true);expect(calculatedInterval.start).toEqual(Date.UTC(2018,0,1,0,0,0));expect(calculatedInterval.end).toEqual(Date.UTC(2019,0,1,0,0,0))}));it("FDT_TC_123 - test interval of 2 year",(function(){var timeDuration={Unit:_datetimeEnums.DatetimeUnits.Year.name,number:2,ms:_datetimeEnums.DatetimeUnits.Year.ms*2},intervalConfig={duration:timeDuration,enableUTC:true},calculatedInterval=(0,_interval.interval)(timestamp,intervalConfig,true);expect(calculatedInterval.start).toEqual(Date.UTC(2018,0,1,0,0,0));expect(calculatedInterval.end).toEqual(Date.UTC(2020,0,1,0,0,0))}));it("FDT_TC_123 - test interval of 1 quarter",(function(){var timeDuration={Unit:_datetimeEnums.DatetimeUnits.Quarter.name,number:1,ms:_datetimeEnums.DatetimeUnits.Quarter.ms*1},intervalConfig={duration:timeDuration,enableUTC:true},calculatedInterval=(0,_interval.interval)(timestamp,intervalConfig,true);expect(calculatedInterval.start).toEqual(Date.UTC(2018,0,1,0,0,0));expect(calculatedInterval.end).toEqual(Date.UTC(2018,3,1,0,0,0))}));it("FDT_TC_123 - test interval of 2 quarters",(function(){var timeDuration={Unit:_datetimeEnums.DatetimeUnits.Quarter.name,number:2,ms:_datetimeEnums.DatetimeUnits.Quarter.ms*2},intervalConfig={duration:timeDuration,enableUTC:true},calculatedInterval=(0,_interval.interval)(timestamp,intervalConfig,true);expect(calculatedInterval.start).toEqual(Date.UTC(2018,0,1,0,0,0));expect(calculatedInterval.end).toEqual(Date.UTC(2018,6,1,0,0,0))}));it("FDT_TC_123 - test interval of 1 month",(function(){var timeDuration={Unit:_datetimeEnums.DatetimeUnits.Month.name,number:1,ms:_datetimeEnums.DatetimeUnits.Month.ms*1},intervalConfig={duration:timeDuration,enableUTC:true},calculatedInterval=(0,_interval.interval)(timestamp,intervalConfig,true);expect(calculatedInterval.start).toEqual(Date.UTC(2018,2,1,0,0,0));expect(calculatedInterval.end).toEqual(Date.UTC(2018,3,1,0,0,0))}));it("FDT_TC_123 - test interval of 2 month",(function(){var timeDuration={Unit:_datetimeEnums.DatetimeUnits.Month.name,number:2,ms:_datetimeEnums.DatetimeUnits.Month.ms*2},intervalConfig={duration:timeDuration,enableUTC:true},calculatedInterval=(0,_interval.interval)(timestamp,intervalConfig,true);expect(calculatedInterval.start).toEqual(Date.UTC(2018,2,1,0,0,0));expect(calculatedInterval.end).toEqual(Date.UTC(2018,4,1,0,0,0))}));it("FDT_TC_123 - test interval of 1 day",(function(){var timeDuration={Unit:_datetimeEnums.DatetimeUnits.Day.name,number:1,ms:_datetimeEnums.DatetimeUnits.Day.ms*1},intervalConfig={duration:timeDuration,enableUTC:true},calculatedInterval=(0,_interval.interval)(timestamp,intervalConfig,true);expect(calculatedInterval.start).toEqual(Date.UTC(2018,2,15,0,0,0));expect(calculatedInterval.end).toEqual(Date.UTC(2018,2,16,0,0,0))}));it("FDT_TC_123 - test interval of 2 day",(function(){var timeDuration={Unit:_datetimeEnums.DatetimeUnits.Day.name,number:2,ms:_datetimeEnums.DatetimeUnits.Day.ms*2},intervalConfig={duration:timeDuration,enableUTC:true},calculatedInterval=(0,_interval.interval)(timestamp,intervalConfig,true);expect(calculatedInterval.start).toEqual(Date.UTC(2018,2,15,0,0,0));expect(calculatedInterval.end).toEqual(Date.UTC(2018,2,17,0,0,0))}));it("FDT_TC_123 - test interval of 1 hour",(function(){var timeDuration={Unit:_datetimeEnums.DatetimeUnits.Hour.name,number:1,ms:_datetimeEnums.DatetimeUnits.Hour.ms*1},intervalConfig={duration:timeDuration,enableUTC:true},calculatedInterval=(0,_interval.interval)(timestamp,intervalConfig,true);expect(calculatedInterval.start).toEqual(Date.UTC(2018,2,15,11,0,0));expect(calculatedInterval.end).toEqual(Date.UTC(2018,2,15,12,0,0))}));it("FDT_TC_123 - test interval of 2 hour",(function(){var timeDuration={Unit:_datetimeEnums.DatetimeUnits.Hour.name,number:2,ms:_datetimeEnums.DatetimeUnits.Hour.ms*2},intervalConfig={duration:timeDuration,enableUTC:true},calculatedInterval=(0,_interval.interval)(timestamp,intervalConfig,true);expect(calculatedInterval.start).toEqual(Date.UTC(2018,2,15,11,0,0));expect(calculatedInterval.end).toEqual(Date.UTC(2018,2,15,13,0,0))}));it("FDT_TC_123 - test interval of 1 minute",(function(){var timeDuration={Unit:_datetimeEnums.DatetimeUnits.Minute.name,number:1,ms:_datetimeEnums.DatetimeUnits.Minute.ms*1},intervalConfig={duration:timeDuration,enableUTC:true},calculatedInterval=(0,_interval.interval)(timestamp,intervalConfig,true);expect(calculatedInterval.start).toEqual(Date.UTC(2018,2,15,11,30,0));expect(calculatedInterval.end).toEqual(Date.UTC(2018,2,15,11,31,0))}));it("FDT_TC_123 - test interval of 2 minute",(function(){var timeDuration={Unit:_datetimeEnums.DatetimeUnits.Minute.name,number:2,ms:_datetimeEnums.DatetimeUnits.Minute.ms*2},intervalConfig={duration:timeDuration,enableUTC:true},calculatedInterval=(0,_interval.interval)(timestamp,intervalConfig,true);expect(calculatedInterval.start).toEqual(Date.UTC(2018,2,15,11,30,0));expect(calculatedInterval.end).toEqual(Date.UTC(2018,2,15,11,32,0))}));it("FDT_TC_123 - test interval of 1 second",(function(){var timeDuration={Unit:_datetimeEnums.DatetimeUnits.Second.name,number:1,ms:_datetimeEnums.DatetimeUnits.Second.ms*1},intervalConfig={duration:timeDuration,enableUTC:true},calculatedInterval=(0,_interval.interval)(timestamp,intervalConfig,true);expect(calculatedInterval.start).toEqual(Date.UTC(2018,2,15,11,30,55));expect(calculatedInterval.end).toEqual(Date.UTC(2018,2,15,11,30,56))}));it("FDT_TC_123 - test interval of 2 second",(function(){var timeDuration={Unit:_datetimeEnums.DatetimeUnits.Second.name,number:2,ms:_datetimeEnums.DatetimeUnits.Second.ms*2},intervalConfig={duration:timeDuration,enableUTC:true},calculatedInterval=(0,_interval.interval)(timestamp,intervalConfig,true);expect(calculatedInterval.start).toEqual(Date.UTC(2018,2,15,11,30,55));expect(calculatedInterval.end).toEqual(Date.UTC(2018,2,15,11,30,57))}));it("FDT_TC_123 - test interval of 1 millisecond",(function(){var timeDuration={Unit:_datetimeEnums.DatetimeUnits.Millisecond.name,number:1,ms:_datetimeEnums.DatetimeUnits.Millisecond.ms*1},intervalConfig={duration:timeDuration,enableUTC:true},calculatedInterval=(0,_interval.interval)(timestamp,intervalConfig,true);expect(calculatedInterval.start).toEqual(Date.UTC(2018,2,15,11,30,55,23));expect(calculatedInterval.end).toEqual(Date.UTC(2018,2,15,11,30,55,24))}));it("FDT_TC_123 - test interval of 2 millisecond",(function(){var timeDuration={Unit:_datetimeEnums.DatetimeUnits.Millisecond.name,number:2,ms:_datetimeEnums.DatetimeUnits.Millisecond.ms*2},intervalConfig={duration:timeDuration,enableUTC:true},calculatedInterval=(0,_interval.interval)(timestamp,intervalConfig,true);expect(calculatedInterval.start).toEqual(Date.UTC(2018,2,15,11,30,55,23));expect(calculatedInterval.end).toEqual(Date.UTC(2018,2,15,11,30,55,25))}))}));describe("interval verify toString",(function(){var timestamp=Date.UTC(2016,1,15,11,30,55);it("1 Year interval",(function(){var timeDuration={Unit:_datetimeEnums.DatetimeUnits.Year.name,number:1,ms:_datetimeEnums.DatetimeUnits.Year.ms*1},intervalConfig={duration:timeDuration,enableUTC:true},calculatedInterval=(0,_interval.interval)(timestamp,intervalConfig,true),expectedOutput="2016";expect(""+calculatedInterval).toEqual(expectedOutput)}));it("3 Year interval",(function(){var timeDuration={Unit:_datetimeEnums.DatetimeUnits.Year.name,number:3,ms:_datetimeEnums.DatetimeUnits.Year.ms*3},intervalConfig={duration:timeDuration,enableUTC:true},calculatedInterval=(0,_interval.interval)(timestamp,intervalConfig,true),expectedOutput="2016 - 2018";expect(""+calculatedInterval).toEqual(expectedOutput)}));it("1 Quarter interval",(function(){var timeDuration={Unit:_datetimeEnums.DatetimeUnits.Quarter.name,number:1,ms:_datetimeEnums.DatetimeUnits.Quarter.ms*1},intervalConfig={duration:timeDuration,enableUTC:true},calculatedInterval=(0,_interval.interval)(timestamp,intervalConfig,true),expectedOutput="Jan 2016 - Mar 2016";expect(""+calculatedInterval).toEqual(expectedOutput)}));it("2 Quarter interval",(function(){var timeDuration={Unit:_datetimeEnums.DatetimeUnits.Quarter.name,number:2,ms:_datetimeEnums.DatetimeUnits.Quarter.ms*2},intervalConfig={duration:timeDuration,enableUTC:true},calculatedInterval=(0,_interval.interval)(timestamp,intervalConfig,true),expectedOutput="Jan 2016 - Jun 2016";expect(""+calculatedInterval).toEqual(expectedOutput)}));it("1 Month interval",(function(){var timeDuration={Unit:_datetimeEnums.DatetimeUnits.Month.name,number:1,ms:_datetimeEnums.DatetimeUnits.Month.ms*1},intervalConfig={duration:timeDuration,enableUTC:true},calculatedInterval=(0,_interval.interval)(timestamp,intervalConfig,true),expectedOutput="Feb 2016";expect(""+calculatedInterval).toEqual(expectedOutput)}));it("2 Month interval",(function(){var timeDuration={Unit:_datetimeEnums.DatetimeUnits.Month.name,number:2,ms:_datetimeEnums.DatetimeUnits.Month.ms*2},intervalConfig={duration:timeDuration,enableUTC:true},calculatedInterval=(0,_interval.interval)(timestamp,intervalConfig,true),expectedOutput="Feb 2016 - Mar 2016";expect(""+calculatedInterval).toEqual(expectedOutput)}));it("1 Week interval",(function(){var timeDuration={Unit:_datetimeEnums.DatetimeUnits.Week.name,number:1,ms:_datetimeEnums.DatetimeUnits.Week.ms*1},intervalConfig={duration:timeDuration,enableUTC:true},calculatedInterval=(0,_interval.interval)(timestamp,intervalConfig,true),expectedOutput="Feb 14, 2016 - Feb 20, 2016";expect(""+calculatedInterval).toEqual(expectedOutput)}));it("2 Week interval",(function(){var timeDuration={Unit:_datetimeEnums.DatetimeUnits.Week.name,number:2,ms:_datetimeEnums.DatetimeUnits.Week.ms*2},intervalConfig={duration:timeDuration,enableUTC:true},calculatedInterval=(0,_interval.interval)(timestamp,intervalConfig,true),expectedOutput="Feb 14, 2016 - Feb 27, 2016";expect(""+calculatedInterval).toEqual(expectedOutput)}));it("1 Day interval",(function(){var timeDuration={Unit:_datetimeEnums.DatetimeUnits.Day.name,number:1,ms:_datetimeEnums.DatetimeUnits.Day.ms*1},intervalConfig={duration:timeDuration,enableUTC:true},calculatedInterval=(0,_interval.interval)(timestamp,intervalConfig,true),expectedOutput="Feb 15, 2016";expect(""+calculatedInterval).toEqual(expectedOutput)}));it("5 Day interval",(function(){var timeDuration={Unit:_datetimeEnums.DatetimeUnits.Day.name,number:5,ms:_datetimeEnums.DatetimeUnits.Day.ms*5},intervalConfig={duration:timeDuration,enableUTC:true},calculatedInterval=(0,_interval.interval)(timestamp,intervalConfig,true),expectedOutput="Feb 15, 2016 - Feb 19, 2016";expect(""+calculatedInterval).toEqual(expectedOutput)}));it("1 Hour interval",(function(){var timeDuration={Unit:_datetimeEnums.DatetimeUnits.Hour.name,number:1,ms:_datetimeEnums.DatetimeUnits.Hour.ms*1},intervalConfig={duration:timeDuration,enableUTC:true},calculatedInterval=(0,_interval.interval)(timestamp,intervalConfig,true),expectedOutput="Feb 15, 2016 11 hrs";expect(""+calculatedInterval).toEqual(expectedOutput)}));it("15 Hour interval",(function(){var timeDuration={Unit:_datetimeEnums.DatetimeUnits.Hour.name,number:15,ms:_datetimeEnums.DatetimeUnits.Hour.ms*15},intervalConfig={duration:timeDuration,enableUTC:true},calculatedInterval=(0,_interval.interval)(timestamp,intervalConfig,true),expectedOutput="Feb 15, 2016 11 hrs - Feb 16, 2016 01 hrs";expect(""+calculatedInterval).toEqual(expectedOutput)}));it("1 Minute interval",(function(){var timeDuration={Unit:_datetimeEnums.DatetimeUnits.Minute.name,number:1,ms:_datetimeEnums.DatetimeUnits.Minute.ms*1},intervalConfig={duration:timeDuration,enableUTC:true},calculatedInterval=(0,_interval.interval)(timestamp,intervalConfig,true),expectedOutput="Feb 15, 2016 11:30";expect(""+calculatedInterval).toEqual(expectedOutput)}));it("45 Minute interval",(function(){var timeDuration={Unit:_datetimeEnums.DatetimeUnits.Minute.name,number:45,ms:_datetimeEnums.DatetimeUnits.Minute.ms*45},intervalConfig={duration:timeDuration,enableUTC:true},calculatedInterval=(0,_interval.interval)(timestamp,intervalConfig,true),expectedOutput="Feb 15, 2016 11:30 - Feb 15, 2016 12:14";expect(""+calculatedInterval).toEqual(expectedOutput)}));it("1 Second interval",(function(){var timeDuration={Unit:_datetimeEnums.DatetimeUnits.Second.name,number:1,ms:_datetimeEnums.DatetimeUnits.Second.ms*1},intervalConfig={duration:timeDuration,enableUTC:true},calculatedInterval=(0,_interval.interval)(timestamp,intervalConfig,true),expectedOutput="Feb 15, 2016 11:30:55";expect(""+calculatedInterval).toEqual(expectedOutput)}));it("100 Second interval",(function(){var timeDuration={Unit:_datetimeEnums.DatetimeUnits.Second.name,number:100,ms:_datetimeEnums.DatetimeUnits.Second.ms*100},intervalConfig={duration:timeDuration,enableUTC:true},calculatedInterval=(0,_interval.interval)(timestamp,intervalConfig,true),expectedOutput="Feb 15, 2016 11:30:55 - Feb 15, 2016 11:32:34";expect(""+calculatedInterval).toEqual(expectedOutput)}));it("1 MS interval",(function(){var timeDuration={Unit:_datetimeEnums.DatetimeUnits.Millisecond.name,number:1,ms:_datetimeEnums.DatetimeUnits.Millisecond.ms*1},intervalConfig={duration:timeDuration,enableUTC:true},calculatedInterval=(0,_interval.interval)(timestamp,intervalConfig,true),expectedOutput="Feb 15, 2016 11:30:55:000";expect(""+calculatedInterval).toEqual(expectedOutput)}));it("5000 MS interval",(function(){var timeDuration={Unit:_datetimeEnums.DatetimeUnits.Millisecond.name,number:5e3,ms:_datetimeEnums.DatetimeUnits.Millisecond.ms*5e3},intervalConfig={duration:timeDuration,enableUTC:true},calculatedInterval=(0,_interval.interval)(timestamp,intervalConfig,true),expectedOutput="Feb 15, 2016 11:30:55:000 - Feb 15, 2016 11:30:59:999";expect(""+calculatedInterval).toEqual(expectedOutput)}))}));