"use strict";var _parserFormatter=require("./parser-formatter");describe("test parseDate util",(function(){it("FDT_TC_134 - basic operation runs",(function(){var dateStr="2018, May 4, 4:40:50:100 pm",format="%Y, %b %e, %I:%M:%S:%L %p";expect((0,_parserFormatter.parseDate)(dateStr,format,true)).toBe(Date.UTC(2018,4,4,16,40,50,100));expect((0,_parserFormatter.parseDate)(dateStr,format)).toBe(+new Date(2018,4,4,16,40,50,100))}));it("FDT_TC_135 - incorrect date throws error",(function(){var dateStr="2018, Maye 4, 4:40:50:100 pm",format="%Y, %b %e, %I:%M:%S:%L %p";expect((function(){(0,_parserFormatter.parseDate)(dateStr,format,true)})).toThrowError("Incorrect string or format provided")}));it("FDT_TC_135 - number date throws error",(function(){var dateStr=1525452000100,format="%Y, %b %e";expect((function(){(0,_parserFormatter.parseDate)(dateStr,format,true)})).toThrowError("Incorrect string or format provided")}));it("FDT_TC_136 - mismatching format throws error",(function(){var dateStr="2018, May 4, 4:40:50:100 pm",format="%Y, %b %e";expect((function(){(0,_parserFormatter.parseDate)(dateStr,format,true)})).toThrowError("Incorrect string or format provided")}));it("FDT_TC_137 - missing date throws error",(function(){var dateStr="",format="%Y, %b %e";expect((function(){(0,_parserFormatter.parseDate)(dateStr,format,true)})).toThrowError("Incorrect string or format provided")}));it("FDT_TC_138 - missing format with custom date string throws error",(function(){var dateStr="2018, May 4, 4:40:50:100 pm",format="";expect((function(){(0,_parserFormatter.parseDate)(dateStr,format,true)})).toThrowError("Incorrect string or format provided")}));it("FDT_TC_138 - missing format with default date string works",(function(){var dateStr="2018-5-4 16:40:50:100",format="";expect((0,_parserFormatter.parseDate)(dateStr,format,true)).toBe(Date.UTC(2018,4,4,16,40,50,100));expect((0,_parserFormatter.parseDate)(dateStr,format)).toBe(+new Date(2018,4,4,16,40,50,100))}))}));describe("test formatDate util",(function(){it("FDT_TC_139 - basic operation runs",(function(){var dateStr="2018, May 4, 04:40:50:100 PM",dateUTC=Date.UTC(2018,4,4,16,40,50,100),dateLocal=+new Date(2018,4,4,16,40,50,100),format="%Y, %b%e, %I:%M:%S:%L %p";expect((0,_parserFormatter.formatDate)(dateUTC,format,true)).toBe(dateStr);expect((0,_parserFormatter.formatDate)(dateLocal,format)).toBe(dateStr)}));it("FDT_TC_140 - missing date throws error",(function(){var dateUTC,dateLocal,format="%Y, %b%e, %I:%M:%S:%L %p";expect((function(){(0,_parserFormatter.formatDate)(dateUTC,format,true)})).toThrowError("Timestamp must be a number: "+dateUTC);expect((function(){(0,_parserFormatter.formatDate)(dateLocal,format)})).toThrowError("Timestamp must be a number: "+dateUTC)}));it("FDT_TC_141 - string date throws error",(function(){var dateUTC="wrong",dateLocal="wrong",format="%Y, %b%e, %I:%M:%S:%L %p";expect((function(){(0,_parserFormatter.formatDate)(dateUTC,format,true)})).toThrowError("Timestamp must be a number: "+dateUTC);expect((function(){(0,_parserFormatter.formatDate)(dateLocal,format)})).toThrowError("Timestamp must be a number: "+dateUTC)}));it("FDT_TC_142 - missing format uses UTC format",(function(){var dateStr="Fri, 4 May 2018, 16:40:50:100",dateUTC=Date.UTC(2018,4,4,16,40,50,100),dateLocal=+new Date(2018,4,4,16,40,50,100),format="";expect((0,_parserFormatter.formatDate)(dateUTC,format,true)).toBe(dateStr);expect((0,_parserFormatter.formatDate)(dateLocal,format)).toBe(dateStr)}))}));