"use strict";var _interopRequireDefault=require("@babel/runtime/helpers/interopRequireDefault");var _extends=require("@babel/runtime/helpers/extends");exports.__esModule=true;exports.default=void 0;var _inheritsLoose2=_interopRequireDefault(require("@babel/runtime/helpers/inheritsLoose"));var _constant=_interopRequireDefault(require("../scale-utils/constant"));var _continuous=_interopRequireWildcard(require("./continuous"));var _pair=_interopRequireDefault(require("../scale-utils/array/pair"));var _pluckNumber=_interopRequireDefault(require("../pluck-number"));function _interopRequireWildcard(e,t){if("function"==typeof WeakMap)var r=new WeakMap,n=new WeakMap;return(_interopRequireWildcard=function _interopRequireWildcard(e,t){if(!t&&e&&e.__esModule)return e;var o,i,f=_extends({},null,{default:e});if(null===e||"object"!=typeof e&&"function"!=typeof e)return f;if(o=t?n:r){if(o.has(e))return o.get(e);o.set(e,f)}for(var _t in e)"default"!==_t&&{}.hasOwnProperty.call(e,_t)&&((i=(o=Object.defineProperty)&&Object.getOwnPropertyDescriptor(e,_t))&&(i.get||i.set)?o(f,_t,i):f[_t]=e[_t]);return f})(e,t)}var deinterpolate=function deinterpolate(_min,_max){var max=_max,min=_min;max=Math.log(max/min);return max?function(ratio){return Math.log(ratio/min)/max}:(0,_constant.default)(max)},reinterpolate=function reinterpolate(min,max){return min<0?function(ratio){return-Math.pow(-max,ratio)*Math.pow(-min,1-ratio)}:function(ratio){return Math.pow(max,ratio)*Math.pow(min,1-ratio)}},pow10=function pow10(x){if(isFinite(x)){return+("1e"+x)}else if(x<0){return 0}return x},powp=function powp(base){if(base===10){return pow10}else if(base===Math.E){return Math.exp}return function(x){return Math.pow(base,x)}},logp=function logp(base){if(base===Math.E){return Math.log}else if(base===10){return Math.log10}else if(base===2){return Math.log2}return function(x){return Math.log(x)/Math.log(base)}},reflect=function reflect(f){return function(x){return-f(-x)}};var ScaleLog=function(_ScaleContinuous){function ScaleLog(){var _this;(_this=_ScaleContinuous.call(this,deinterpolate,reinterpolate)||this).setDomain([1,10]);_this.base=10;_this.logs=logp(_this.base);_this.pows=powp(_this.base);return _this}(0,_inheritsLoose2.default)(ScaleLog,_ScaleContinuous);var _proto=ScaleLog.prototype;_proto._rescaleLog=function _rescaleLog(){this.logs=logp(this.base);this.pows=powp(this.base);if(this.getDomain()[0]<0){this.logs=reflect(this.logs);this.pows=reflect(this.pows)}return this};_proto.setBase=function setBase(base){if(base===void 0){base=10}this.base=Number(base);return this._rescaleLog()};_proto.getBase=function getBase(){return this.base};_proto.setDomain=function setDomain(domain){if(domain===void 0){domain=[1,10]}_ScaleContinuous.prototype.setDomain.call(this,domain);return this._rescaleLog()};_proto.nice=function nice(){var _this$getDomain=this.getDomain(),val1=_this$getDomain[0],val2=_this$getDomain[1],base=this.base,minLog,maxLog;if(val1===val2){val1-=val1/100}minLog=Math.log(val1)/Math.log(base);maxLog=Math.log(val2)/Math.log(base);if(minLog%1||maxLog%1){if(val1<=val2){val1=this.pows(Math.floor(minLog));val2=this.pows(Math.ceil(maxLog))}else{val1=this.pows(Math.ceil(minLog));val2=this.pows(Math.floor(maxLog))}this.setDomain([val1,val2])}return this};_proto.tickFormat=function tickFormat(_count,_specifier){var base=this.base;var specifier=_specifier,count=_count;if(specifier==null)specifier=base===10?".0e":",";if(typeof specifier!=="function")specifier=this._localeConverter.formatter(specifier);if(count==null)count=10;return function(d){return specifier.format(d)}};_proto.ticks=function ticks(){var _this$getDomain2=this.getDomain(),min=_this$getDomain2[0],max=_this$getDomain2[1],maxLogY,isReverse=1,minLogY,iniValue,checkValue,counter=0,divLines=[],divLineValue,r,i,base=this.base;if(min<=0||max<=0){return divLines}if(min>max){var _this$getDomain3=this.getDomain();max=_this$getDomain3[0];min=_this$getDomain3[1];isReverse=0}if(base>1){maxLogY=Math.ceil(Math.log(max)/Math.log(base));minLogY=Math.floor(Math.log(min)/Math.log(base));iniValue=maxLogY;checkValue=minLogY}else if(base>0&&base<1){maxLogY=Math.floor(Math.log(max)/Math.log(base));minLogY=Math.ceil(Math.log(min)/Math.log(base));iniValue=minLogY;checkValue=maxLogY}r=maxLogY;for(i=iniValue;i>=checkValue;--i){divLineValue=this.pows(r);if(min<=divLineValue&&max>=divLineValue){divLines[counter++]=divLineValue}if(base>1){r--}else{r++}}return this.majorTicks=isReverse?divLines.reverse():divLines};_proto.copy=function copy(){return(0,_continuous.copyScale)(this,(new ScaleLog).setBase(this.base))};_proto.minorTicks=function minorTicks(_numMinorTicks,majorTicks){if(majorTicks===void 0){majorTicks=this.majorTicks||this.ticks()}var base=this.base,tickPairs=(0,_pair.default)(majorTicks),i,minorTicks=[],baseWithRespectTo10=Math.log(base)/Math.log(10),d=base>1?-1:1,maxLogY,subInterval,slabInterval,divLineValue,numMinorTicks=_numMinorTicks;numMinorTicks=(0,_pluckNumber.default)(Number(numMinorTicks),baseWithRespectTo10%1?4:8);tickPairs.forEach((function(_ref){var min=_ref[0],max=_ref[1];if(base>1){maxLogY=Math.ceil(Math.log(max)/Math.log(base))}else if(base>0&&base<1){maxLogY=Math.floor(Math.log(max)/Math.log(base))}slabInterval=Math.pow(base,maxLogY)-Math.pow(base,maxLogY+d);subInterval=slabInterval/(numMinorTicks+1);for(i=1;i<=numMinorTicks;++i){divLineValue=Math.pow(base,maxLogY+d)+subInterval*i;if(min<=divLineValue&&max>=divLineValue){minorTicks.push(divLineValue)}}}));return minorTicks};_proto.contextTicks=function contextTicks(){return this.contextTicksArr||[]};_proto.getType=function getType(){return"log"};return ScaleLog}(_continuous.default);var _default=exports.default=ScaleLog;