"use strict";var _interopRequireDefault=require("@babel/runtime/helpers/interopRequireDefault");var _time=_interopRequireDefault(require("./time"));var _minute=_interopRequireDefault(require("../time-intervals/minute"));var _day=_interopRequireDefault(require("../time-intervals/day"));var _week=_interopRequireDefault(require("../time-intervals/week"));var _month=_interopRequireDefault(require("../time-intervals/month"));var _year=_interopRequireDefault(require("../time-intervals/year"));var localDate=function localDate(year,month,day,hours,minutes,seconds,milliseconds){if(year===null||typeof year==="undefined")year=0;if(month===null||typeof month==="undefined")month=0;if(day===null||typeof day==="undefined")day=1;if(hours===null||typeof hours==="undefined")hours=0;if(minutes===null||typeof minutes==="undefined")minutes=0;if(seconds===null||typeof seconds==="undefined")seconds=0;if(milliseconds===null||typeof milliseconds==="undefined")milliseconds=0;if(year>=0&&year<100){var date=new Date(-1,month,day,hours,minutes,seconds,milliseconds);date.setFullYear(year);return date}return new Date(year,month,day,hours,minutes,seconds,milliseconds)};describe("A time scale should",(function(){it("be unable to deal with invalidly massive domains",(function(){var timeScale=(new _time.default).setDomain([-1e50,1e50]);expect(Number(timeScale.getDomain()[0])).toBeNaN();expect(Number(timeScale.getDomain()[1])).toBeNaN();expect(timeScale.ticks(10)).toEqual([])}));describe("be able to nice",(function(){it("by 10 units by default",(function(){var timeScale=(new _time.default).setDomain([localDate(2009,0,1,0,17),localDate(2009,0,1,23,42)]);expect(timeScale.nice().getDomain()).toEqual([localDate(2009,0,1),localDate(2009,0,2)])}));describe("by a given number of time units",(function(){it("correctly",(function(){var timeScale=(new _time.default).setDomain([localDate(2009,0,1,0,17),localDate(2009,0,1,23,42)]);expect(timeScale.nice(100).getDomain()).toEqual([localDate(2009,0,1,0,15),localDate(2009,0,1,23,45)]);expect(timeScale.nice(10).getDomain()).toEqual([localDate(2009,0,1),localDate(2009,0,2)])}));it("at sub second level domains",(function(){var timeScale=(new _time.default).setDomain([localDate(2013,0,1,12,0,0,0),localDate(2013,0,1,12,0,0,128)]);expect(timeScale.nice(10).getDomain()).toEqual([localDate(2013,0,1,12,0,0,0),localDate(2013,0,1,12,0,0,130)])}));it("at multi year level domains",(function(){var timeScale=(new _time.default).setDomain([localDate(2001,0,1),localDate(2138,0,1)]);expect(timeScale.nice(10).getDomain()).toEqual([localDate(2e3,0,1),localDate(2140,0,1)])}));it("when domains are empty",(function(){var timeScale=(new _time.default).setDomain([localDate(2009,0,1,0,12),localDate(2009,0,1,0,12)]);expect(timeScale.nice(10).getDomain()).toEqual([localDate(2009,0,1,0,12),localDate(2009,0,1,0,12)])}))}));describe("by a given of time interval",(function(){it("correctly",(function(){var x=(new _time.default).setDomain([localDate(2009,0,1,0,12),localDate(2009,0,1,23,48)]);expect(x.nice(_day.default).getDomain()).toEqual([localDate(2009,0,1),localDate(2009,0,2)]);expect(x.nice(_week.default).getDomain()).toEqual([localDate(2008,11,28),localDate(2009,0,4)]);expect(x.nice(_month.default).getDomain()).toEqual([localDate(2008,11,1),localDate(2009,1,1)]);expect(x.nice(_year.default).getDomain()).toEqual([localDate(2008,0,1),localDate(2010,0,1)])}));it("when domains are empty",(function(){var timeScale=(new _time.default).setDomain([localDate(2009,0,1,0,12),localDate(2009,0,1,0,12)]);expect(timeScale.nice(_day.default).getDomain()).toEqual([localDate(2009,0,1),localDate(2009,0,2)])}));it("when the domain is polylinear, only affecting its extent",(function(){var timeScale=(new _time.default).setDomain([localDate(2009,0,1,0,12),localDate(2009,0,1,23,48),localDate(2009,0,2,23,48)]).nice(_day.default);expect(timeScale.getDomain()).toEqual([localDate(2009,0,1),localDate(2009,0,1,23,48),localDate(2009,0,3)])}))}));it("by the specified time interval and step",(function(){var timeScale=(new _time.default).setDomain([localDate(2009,0,1,0,12),localDate(2009,0,1,23,48)]);expect(timeScale.nice(_day.default,3).getDomain()).toEqual([localDate(2009,0,1),localDate(2009,0,4)]);expect(timeScale.nice(_week.default,2).getDomain()).toEqual([localDate(2008,11,21),localDate(2009,0,4)]);expect(timeScale.nice(_month.default,3).getDomain()).toEqual([localDate(2008,9,1),localDate(2009,3,1)]);expect(timeScale.nice(_year.default,10).getDomain()).toEqual([localDate(2e3,0,1),localDate(2010,0,1)])}))}));describe("be able to copy itself",(function(){it("such that changes to its domain does not affect the copied scale's domain",(function(){var x=(new _time.default).setDomain([localDate(2009,0,1),localDate(2010,0,1)]),y=x.copy();x.setDomain([localDate(2010,0,1),localDate(2011,0,1)]);expect(x.getRangeValue(localDate(2010,0,1))).toBe(0);expect(y.getRangeValue(localDate(2010,0,1))).toBe(1);expect(y.getDomain()).toEqual([localDate(2009,0,1),localDate(2010,0,1)]);y.setDomain([localDate(2011,0,1),localDate(2012,0,1)]);expect(x.getRangeValue(localDate(2011,0,1))).toBe(1);expect(y.getRangeValue(localDate(2011,0,1))).toBe(0);expect(x.getDomain()).toEqual([localDate(2010,0,1),localDate(2011,0,1)]);expect(y.getDomain()).toEqual([localDate(2011,0,1),localDate(2012,0,1)])}));it("such that changes to its range does not affect the copied scale's range",(function(){var x=(new _time.default).setDomain([localDate(2009,0,1),localDate(2010,0,1)]),y=x.copy();x.setRange([1,2]);expect(x.getDomainValue(1)).toEqual(localDate(2009,0,1));expect(y.getDomainValue(1)).toEqual(localDate(2010,0,1));expect(y.getRange()).toEqual([0,1]);y.setRange([2,3]);expect(x.getDomainValue(2)).toEqual(localDate(2010,0,1));expect(y.getDomainValue(2)).toEqual(localDate(2009,0,1));expect(x.getRange()).toEqual([1,2]);expect(y.getRange()).toEqual([2,3])}));it("such that changes to its interpolator is isolated from the copied scale",(function(){var x=(new _time.default).setDomain([localDate(2009,0,1),localDate(2010,0,1)]).setRange([1,10]),i=x.getInterpolate(),y=x.copy();x.setInterpolate((function(){return function(){return 5}}));expect(x.getRangeValue(localDate(2009,6,1))).toBe(5);expect(y.getRangeValue(localDate(2009,6,1))).toBeCloseTo(5,0);expect(y.getInterpolate()).toEqual(i)}));it("such that changes to its clamping is isolated from the copied scale",(function(){var x=(new _time.default).setDomain([localDate(2009,0,1),localDate(2010,0,1)]).setClamp(true),y=x.copy();x.setClamp(false);expect(x.getRangeValue(localDate(2011,0,1))).toBe(2);expect(y.getRangeValue(localDate(2011,0,1))).toBe(1);expect(y.getClamp()).toBeTruthy();y.setClamp(false);expect(x.getRangeValue(localDate(2011,0,1))).toBe(2);expect(y.getRangeValue(localDate(2011,0,1))).toBe(2);expect(x.getClamp()).toBeFalsy()}))}));it("never return a value outside its domain when clamped",(function(){var timeScale=(new _time.default).setClamp(true);expect(timeScale.getDomainValue(0)instanceof Date).toBeTruthy();expect(timeScale.getDomainValue(0)).not.toBe(timeScale.getDomainValue(0));expect(+timeScale.getDomainValue(-1)).toEqual(+timeScale.getDomain()[0]);expect(+timeScale.getDomainValue(0)).toEqual(+timeScale.getDomain()[0]);expect(+timeScale.getDomainValue(1)).toEqual(+timeScale.getDomain()[1]);expect(+timeScale.getDomainValue(2)).toEqual(+timeScale.getDomain()[1])}));describe("be able to generate ticks",(function(){it("at the specified tick intervals",(function(){var timeScale=(new _time.default).setDomain([localDate(2011,0,1,12,1,0),localDate(2011,0,1,12,4,4)]);expect(timeScale.ticks(_minute.default)).toEqual([localDate(2011,0,1,12,1),localDate(2011,0,1,12,2),localDate(2011,0,1,12,3),localDate(2011,0,1,12,4)])}));it("at the specified tick intervals and steps",(function(){var timeScale=(new _time.default).setDomain([localDate(2011,0,1,12,0,0),localDate(2011,0,1,12,33,4)]);expect(timeScale.ticks(_minute.default,10)).toEqual([localDate(2011,0,1,12,0),localDate(2011,0,1,12,10),localDate(2011,0,1,12,20),localDate(2011,0,1,12,30)])}));it("at sub-second intervals",(function(){var timeScale=(new _time.default).setDomain([localDate(2011,0,1,12,0,0),localDate(2011,0,1,12,0,1)]);expect(timeScale.ticks(4)).toEqual([localDate(2011,0,1,12,0,0,0),localDate(2011,0,1,12,0,0,200),localDate(2011,0,1,12,0,0,400),localDate(2011,0,1,12,0,0,600),localDate(2011,0,1,12,0,0,800),localDate(2011,0,1,12,0,1,0)])}));it("at 1-second intervals",(function(){var timeScale=(new _time.default).setDomain([localDate(2011,0,1,12,0,0),localDate(2011,0,1,12,0,4)]);expect(timeScale.ticks(4)).toEqual([localDate(2011,0,1,12,0,0),localDate(2011,0,1,12,0,1),localDate(2011,0,1,12,0,2),localDate(2011,0,1,12,0,3),localDate(2011,0,1,12,0,4)])}));it("at 5-second intervals",(function(){var timeScale=(new _time.default).setDomain([localDate(2011,0,1,12,0,0),localDate(2011,0,1,12,0,20)]);expect(timeScale.ticks(4)).toEqual([localDate(2011,0,1,12,0,0),localDate(2011,0,1,12,0,5),localDate(2011,0,1,12,0,10),localDate(2011,0,1,12,0,15),localDate(2011,0,1,12,0,20)])}));it("at 15-second intervals",(function(){var timeScale=(new _time.default).setDomain([localDate(2011,0,1,12,0,0),localDate(2011,0,1,12,0,50)]);expect(timeScale.ticks(4)).toEqual([localDate(2011,0,1,12,0,0),localDate(2011,0,1,12,0,15),localDate(2011,0,1,12,0,30),localDate(2011,0,1,12,0,45)])}));it("at 30-second intervals",(function(){var timeScale=(new _time.default).setDomain([localDate(2011,0,1,12,0,0),localDate(2011,0,1,12,1,50)]);expect(timeScale.ticks(4)).toEqual([localDate(2011,0,1,12,0,0),localDate(2011,0,1,12,0,30),localDate(2011,0,1,12,1,0),localDate(2011,0,1,12,1,30)])}));it("at 1-minute intervals",(function(){var timeScale=(new _time.default).setDomain([localDate(2011,0,1,12,0,27),localDate(2011,0,1,12,4,12)]);expect(timeScale.ticks(4)).toEqual([localDate(2011,0,1,12,1),localDate(2011,0,1,12,2),localDate(2011,0,1,12,3),localDate(2011,0,1,12,4)])}));it("at 5-minute intervals",(function(){var timeScale=(new _time.default).setDomain([localDate(2011,0,1,12,3,27),localDate(2011,0,1,12,21,12)]);expect(timeScale.ticks(4)).toEqual([localDate(2011,0,1,12,5),localDate(2011,0,1,12,10),localDate(2011,0,1,12,15),localDate(2011,0,1,12,20)])}));it("at 15-minute intervals",(function(){var timeScale=(new _time.default).setDomain([localDate(2011,0,1,12,8,27),localDate(2011,0,1,13,4,12)]);expect(timeScale.ticks(4)).toEqual([localDate(2011,0,1,12,15),localDate(2011,0,1,12,30),localDate(2011,0,1,12,45),localDate(2011,0,1,13,0)])}));it("at 30-minute intervals",(function(){var timeScale=(new _time.default).setDomain([localDate(2011,0,1,12,28,27),localDate(2011,0,1,14,4,12)]);expect(timeScale.ticks(4)).toEqual([localDate(2011,0,1,12,30),localDate(2011,0,1,13,0),localDate(2011,0,1,13,30),localDate(2011,0,1,14,0)])}));it("at 1-hour intervals",(function(){var timeScale=(new _time.default).setDomain([localDate(2011,0,1,12,28,27),localDate(2011,0,1,16,34,12)]);expect(timeScale.ticks(4)).toEqual([localDate(2011,0,1,13,0),localDate(2011,0,1,14,0),localDate(2011,0,1,15,0),localDate(2011,0,1,16,0)])}));it("at 3-hour intervals",(function(){var timeScale=(new _time.default).setDomain([localDate(2011,0,1,14,28,27),localDate(2011,0,2,1,34,12)]);expect(timeScale.ticks(4)).toEqual([localDate(2011,0,1,15,0),localDate(2011,0,1,18,0),localDate(2011,0,1,21,0),localDate(2011,0,2,0,0)])}));it("at 6-hour intervals",(function(){var timeScale=(new _time.default).setDomain([localDate(2011,0,1,16,28,27),localDate(2011,0,2,14,34,12)]);expect(timeScale.ticks(4)).toEqual([localDate(2011,0,1,18,0),localDate(2011,0,2,0,0),localDate(2011,0,2,6,0),localDate(2011,0,2,12,0)])}));it("at 12-hour intervals",(function(){var timeScale=(new _time.default).setDomain([localDate(2011,0,1,16,28,27),localDate(2011,0,3,21,34,12)]);expect(timeScale.ticks(4)).toEqual([localDate(2011,0,2,0,0),localDate(2011,0,2,12,0),localDate(2011,0,3,0,0),localDate(2011,0,3,12,0)])}));it("at 1-day intervals",(function(){var timeScale=(new _time.default).setDomain([localDate(2011,0,1,16,28,27),localDate(2011,0,5,21,34,12)]);expect(timeScale.ticks(4)).toEqual([localDate(2011,0,2,0,0),localDate(2011,0,3,0,0),localDate(2011,0,4,0,0),localDate(2011,0,5,0,0)])}));it("at 2-day intervals",(function(){var timeScale=(new _time.default).setDomain([localDate(2011,0,2,16,28,27),localDate(2011,0,9,21,34,12)]);expect(timeScale.ticks(4)).toEqual([localDate(2011,0,3,0,0),localDate(2011,0,5,0,0),localDate(2011,0,7,0,0),localDate(2011,0,9,0,0)])}));it("at 1-week intervals",(function(){var timeScale=(new _time.default).setDomain([localDate(2011,0,1,16,28,27),localDate(2011,0,23,21,34,12)]);expect(timeScale.ticks(4)).toEqual([localDate(2011,0,2,0,0),localDate(2011,0,9,0,0),localDate(2011,0,16,0,0),localDate(2011,0,23,0,0)])}));it("at 1-month intervals",(function(){var timeScale=(new _time.default).setDomain([localDate(2011,0,18),localDate(2011,4,2)]);expect(timeScale.ticks(4)).toEqual([localDate(2011,1,1,0,0),localDate(2011,2,1,0,0),localDate(2011,3,1,0,0),localDate(2011,4,1,0,0)])}));it("at 3-month intervals",(function(){var timeScale=(new _time.default).setDomain([localDate(2010,11,18),localDate(2011,10,2)]);expect(timeScale.ticks(4)).toEqual([localDate(2011,0,1,0,0),localDate(2011,3,1,0,0),localDate(2011,6,1,0,0),localDate(2011,9,1,0,0)])}));it("at 1-year intervals",(function(){var timeScale=(new _time.default).setDomain([localDate(2010,11,18),localDate(2014,2,2)]);expect(timeScale.ticks(4)).toEqual([localDate(2011,0,1,0,0),localDate(2012,0,1,0,0),localDate(2013,0,1,0,0),localDate(2014,0,1,0,0)])}));it("at multi-year intervals",(function(){var timeScale=(new _time.default).setDomain([localDate(0,11,18),localDate(2014,2,2)]);expect(timeScale.ticks(6)).toEqual([localDate(500,0,1,0,0),localDate(1e3,0,1,0,0),localDate(1500,0,1,0,0),localDate(2e3,0,1,0,0)])}))}));describe("be able to create a formatter which",(function(){it("formats to a year on New Year's Day",(function(){var f=(new _time.default).tickFormat();expect(f(localDate(2011,0,1))).toBe("2011");expect(f(localDate(2012,0,1))).toBe("2012");expect(f(localDate(2013,0,1))).toBe("2013")}));it("formats to a month on the 1st of each month",(function(){var f=(new _time.default).tickFormat();expect(f(localDate(2011,1,1))).toBe("February");expect(f(localDate(2011,2,1))).toBe("March");expect(f(localDate(2011,3,1))).toBe("April")}));it("formats to a week on Sunday midnight",(function(){var f=(new _time.default).tickFormat();expect(f(localDate(2011,1,6))).toBe("Feb 06");expect(f(localDate(2011,1,13))).toBe("Feb 13");expect(f(localDate(2011,1,20))).toBe("Feb 20")}));it("formats to a date on midnight",(function(){var f=(new _time.default).tickFormat();expect(f(localDate(2011,1,2))).toBe("Wed 02");expect(f(localDate(2011,1,3))).toBe("Thu 03");expect(f(localDate(2011,1,4))).toBe("Fri 04")}));it("formats to an hour on minute zero",(function(){var f=(new _time.default).tickFormat();expect(f(localDate(2011,1,2,11))).toBe("11 AM");expect(f(localDate(2011,1,2,12))).toBe("12 PM");expect(f(localDate(2011,1,2,13))).toBe("01 PM")}));it("formats to a minute on second zero",(function(){var f=(new _time.default).tickFormat();expect(f(localDate(2011,1,2,11,59))).toBe("11:59");expect(f(localDate(2011,1,2,12,1))).toBe("12:01");expect(f(localDate(2011,1,2,12,2))).toBe("12:02")}));it("formats to second in any other case",(function(){var f=(new _time.default).tickFormat();expect(f(localDate(2011,1,2,12,1,9))).toBe(":09");expect(f(localDate(2011,1,2,12,1,10))).toBe(":10");expect(f(localDate(2011,1,2,12,1,11))).toBe(":11")}));it("formats to the given specifier",(function(){var f=(new _time.default).tickFormat("%c");expect(f(localDate(2011,1,2,12))).toBe("2/2/2011, 12:00:00 PM")}))}));it("be able to generate descending ticks for a descending domain",(function(){var timeScale=new _time.default;expect(timeScale.setDomain([localDate(2014,2,2),localDate(2010,11,18)]).ticks(4)).toEqual([localDate(2014,0,1,0,0),localDate(2013,0,1,0,0),localDate(2012,0,1,0,0),localDate(2011,0,1,0,0)]);expect(timeScale.setDomain([localDate(2011,10,2),localDate(2010,11,18)]).ticks(4)).toEqual([localDate(2011,9,1,0,0),localDate(2011,6,1,0,0),localDate(2011,3,1,0,0),localDate(2011,0,1,0,0)])}));it("be able to generate one tick if the domain is collapsed",(function(){var timeScale=(new _time.default).setDomain([localDate(2014,2,2),localDate(2014,2,2)]);expect(timeScale.ticks(6)).toEqual([localDate(2014,2,2)])}))}));