"use strict";var _interopRequireDefault=require("@babel/runtime/helpers/interopRequireDefault");var _utc=_interopRequireDefault(require("./utc"));var _utc2=require("../time-intervals/utc");var isNil=function isNil(x){return x===null||typeof x==="undefined"},utcDate=function utcDate(year,month,day,hours,minutes,seconds,milliseconds){if(isNil(year))year=0;if(isNil(month))month=0;if(isNil(day))day=1;if(isNil(hours))hours=0;if(isNil(minutes))minutes=0;if(isNil(seconds))seconds=0;if(isNil(milliseconds))milliseconds=0;if(year>=0&&year<100){var date=new Date(Date.UTC(-1,month,day,hours,minutes,seconds,milliseconds));date.setUTCFullYear(year);return date}return new Date(Date.UTC(year,month,day,hours,minutes,seconds,milliseconds))};describe("A UTC time scale",(function(){describe("should be able to nice",(function(){it("to 10 units by default",(function(){var s=(new _utc.default).setDomain([utcDate(2009,0,1,0,17),utcDate(2009,0,1,23,42)]);expect(s.nice().getDomain()).toEqual([utcDate(2009,0,1),utcDate(2009,0,2)])}));it("sub-second domains",(function(){var s=(new _utc.default).setDomain([utcDate(2013,0,1,12,0,0,0),utcDate(2013,0,1,12,0,0,128)]);expect(s.nice().getDomain()).toEqual([utcDate(2013,0,1,12,0,0,0),utcDate(2013,0,1,12,0,0,130)])}));it("multi-year domains",(function(){var s=(new _utc.default).setDomain([utcDate(2001,0,1),utcDate(2138,0,1)]);expect(s.nice().getDomain()).toEqual([utcDate(2e3,0,1),utcDate(2140,0,1)])}));it("empty domains",(function(){var s=(new _utc.default).setDomain([utcDate(2009,0,1,0,12),utcDate(2009,0,1,0,12)]);expect(s.nice().getDomain()).toEqual([utcDate(2009,0,1,0,12),utcDate(2009,0,1,0,12)])}));it("to the specified tick count",(function(){var s=(new _utc.default).setDomain([utcDate(2009,0,1,0,17),utcDate(2009,0,1,23,42)]);expect(s.nice(100).getDomain()).toEqual([utcDate(2009,0,1,0,15),utcDate(2009,0,1,23,45)]);expect(s.nice(10).getDomain()).toEqual([utcDate(2009,0,1),utcDate(2009,0,2)])}));it("using the specified time interval",(function(){var s=(new _utc.default).setDomain([utcDate(2009,0,1,0,12),utcDate(2009,0,1,23,48)]);expect(s.nice(_utc2.utcDay).getDomain()).toEqual([utcDate(2009,0,1),utcDate(2009,0,2)]);expect(s.nice(_utc2.utcWeek).getDomain()).toEqual([utcDate(2008,11,28),utcDate(2009,0,4)]);expect(s.nice(_utc2.utcMonth).getDomain()).toEqual([utcDate(2008,11,1),utcDate(2009,1,1)]);expect(s.nice(_utc2.utcYear).getDomain()).toEqual([utcDate(2008,0,1),utcDate(2010,0,1)])}));it("empty domains using the given interval",(function(){var s=(new _utc.default).setDomain([utcDate(2009,0,1,0,12),utcDate(2009,0,1,0,12)]);expect(s.nice(_utc2.utcDay).getDomain()).toEqual([utcDate(2009,0,1),utcDate(2009,0,2)])}));it("a polylinear domain, only affecting its extent",(function(){var s=(new _utc.default).setDomain([utcDate(2009,0,1,0,12),utcDate(2009,0,1,23,48),utcDate(2009,0,2,23,48)]).nice(_utc2.utcDay);expect(s.getDomain()).toEqual([utcDate(2009,0,1),utcDate(2009,0,1,23,48),utcDate(2009,0,3)])}));it("using the specified time interval and step",(function(){var s=(new _utc.default).setDomain([utcDate(2009,0,1,0,12),utcDate(2009,0,1,23,48)]);expect(s.nice(_utc2.utcDay,3).getDomain()).toEqual([utcDate(2009,0,1),utcDate(2009,0,4)]);expect(s.nice(_utc2.utcWeek,2).getDomain()).toEqual([utcDate(2008,11,21),utcDate(2009,0,4)]);expect(s.nice(_utc2.utcMonth,3).getDomain()).toEqual([utcDate(2008,9,1),utcDate(2009,3,1)]);expect(s.nice(_utc2.utcYear,10).getDomain()).toEqual([utcDate(2e3,0,1),utcDate(2010,0,1)])}))}));describe("should be able to copy itself and",(function(){it("isolate changes to the domain",(function(){var s=(new _utc.default).setDomain([utcDate(2009,0,1),utcDate(2010,0,1)]),y=s.copy();s.setDomain([utcDate(2010,0,1),utcDate(2011,0,1)]);expect(y.getDomain()).toEqual([utcDate(2009,0,1),utcDate(2010,0,1)]);expect(s.getRangeValue(utcDate(2010,0,1))).toBe(0);expect(y.getRangeValue(utcDate(2010,0,1))).toBe(1);y.setDomain([utcDate(2011,0,1),utcDate(2012,0,1)]);expect(s.getRangeValue(utcDate(2011,0,1))).toBe(1);expect(y.getRangeValue(utcDate(2011,0,1))).toBe(0);expect(s.getDomain()).toEqual([utcDate(2010,0,1),utcDate(2011,0,1)]);expect(y.getDomain()).toEqual([utcDate(2011,0,1),utcDate(2012,0,1)])}));it("isolate changes to the range",(function(){var s=(new _utc.default).setDomain([utcDate(2009,0,1),utcDate(2010,0,1)]),y=s.copy();s.setRange([1,2]);expect(s.getDomainValue(1)).toEqual(utcDate(2009,0,1));expect(y.getDomainValue(1)).toEqual(utcDate(2010,0,1));expect(y.getRange()).toEqual([0,1]);y.setRange([2,3]);expect(s.getDomainValue(2)).toEqual(utcDate(2010,0,1));expect(y.getDomainValue(2)).toEqual(utcDate(2009,0,1));expect(s.getRange()).toEqual([1,2]);expect(y.getRange()).toEqual([2,3])}));it("isolate changes to the interpolator",(function(){var s=(new _utc.default).setDomain([utcDate(2009,0,1),utcDate(2010,0,1)]).setRange([1,10]),i=s.getInterpolate(),y=s.copy();s.setInterpolate((function(){return function(){return 5}}));expect(y.getInterpolate()).toEqual(i);expect(s.getRangeValue(utcDate(2009,6,1))).toEqual(5);expect(y.getRangeValue(utcDate(2009,6,1))).toBeCloseTo(5,0)}));it("isolate changes to clamping",(function(){var s=(new _utc.default).setDomain([utcDate(2009,0,1),utcDate(2010,0,1)]).setClamp(true),y=s.copy();s.setClamp(false);expect(s.getRangeValue(utcDate(2011,0,1))).toBe(2);expect(y.getRangeValue(utcDate(2011,0,1))).toBe(1);expect(y.getClamp()).toBe(true);y.setClamp(false);expect(s.getRangeValue(utcDate(2011,0,1))).toBe(2);expect(y.getRangeValue(utcDate(2011,0,1))).toBe(2);expect(s.getClamp()).toBeFalsy()}))}));describe("should be able to generate ticks",(function(){it("scaleUtc.ticks(interval) observes the specified tick interval",(function(){var x=(new _utc.default).setDomain([utcDate(2011,0,1,12,1,0),utcDate(2011,0,1,12,4,4)]);expect(x.ticks(_utc2.utcMinute)).toEqual([utcDate(2011,0,1,12,1),utcDate(2011,0,1,12,2),utcDate(2011,0,1,12,3),utcDate(2011,0,1,12,4)])}));it("scaleUtc.ticks(interval) observes the specified named tick interval",(function(){var x=(new _utc.default).setDomain([utcDate(2011,0,1,12,1,0),utcDate(2011,0,1,12,4,4)]);expect(x.ticks(_utc2.utcMinute)).toEqual([utcDate(2011,0,1,12,1),utcDate(2011,0,1,12,2),utcDate(2011,0,1,12,3),utcDate(2011,0,1,12,4)])}));it("scaleUtc.ticks(interval, step) observes the specified tick interval and step",(function(){var x=(new _utc.default).setDomain([utcDate(2011,0,1,12,0,0),utcDate(2011,0,1,12,33,4)]);expect(x.ticks(_utc2.utcMinute,10)).toEqual([utcDate(2011,0,1,12,0),utcDate(2011,0,1,12,10),utcDate(2011,0,1,12,20),utcDate(2011,0,1,12,30)])}));it("scaleUtc.ticks(count) can generate sub-second ticks",(function(){var x=(new _utc.default).setDomain([utcDate(2011,0,1,12,0,0),utcDate(2011,0,1,12,0,1)]);expect(x.ticks(4)).toEqual([utcDate(2011,0,1,12,0,0,0),utcDate(2011,0,1,12,0,0,200),utcDate(2011,0,1,12,0,0,400),utcDate(2011,0,1,12,0,0,600),utcDate(2011,0,1,12,0,0,800),utcDate(2011,0,1,12,0,1,0)])}));it("scaleUtc.ticks(count) can generate 1-second ticks",(function(){var x=(new _utc.default).setDomain([utcDate(2011,0,1,12,0,0),utcDate(2011,0,1,12,0,4)]);expect(x.ticks(4)).toEqual([utcDate(2011,0,1,12,0,0),utcDate(2011,0,1,12,0,1),utcDate(2011,0,1,12,0,2),utcDate(2011,0,1,12,0,3),utcDate(2011,0,1,12,0,4)])}));it("scaleUtc.ticks(count) can generate 5-second ticks",(function(){var x=(new _utc.default).setDomain([utcDate(2011,0,1,12,0,0),utcDate(2011,0,1,12,0,20)]);expect(x.ticks(4)).toEqual([utcDate(2011,0,1,12,0,0),utcDate(2011,0,1,12,0,5),utcDate(2011,0,1,12,0,10),utcDate(2011,0,1,12,0,15),utcDate(2011,0,1,12,0,20)])}));it("scaleUtc.ticks(count) can generate 15-second ticks",(function(){var x=(new _utc.default).setDomain([utcDate(2011,0,1,12,0,0),utcDate(2011,0,1,12,0,50)]);expect(x.ticks(4)).toEqual([utcDate(2011,0,1,12,0,0),utcDate(2011,0,1,12,0,15),utcDate(2011,0,1,12,0,30),utcDate(2011,0,1,12,0,45)])}));it("scaleUtc.ticks(count) can generate 30-second ticks",(function(){var x=(new _utc.default).setDomain([utcDate(2011,0,1,12,0,0),utcDate(2011,0,1,12,1,50)]);expect(x.ticks(4)).toEqual([utcDate(2011,0,1,12,0,0),utcDate(2011,0,1,12,0,30),utcDate(2011,0,1,12,1,0),utcDate(2011,0,1,12,1,30)])}));it("scaleUtc.ticks(count) can generate 1-minute ticks",(function(){var x=(new _utc.default).setDomain([utcDate(2011,0,1,12,0,27),utcDate(2011,0,1,12,4,12)]);expect(x.ticks(4)).toEqual([utcDate(2011,0,1,12,1),utcDate(2011,0,1,12,2),utcDate(2011,0,1,12,3),utcDate(2011,0,1,12,4)])}));it("scaleUtc.ticks(count) can generate 5-minute ticks",(function(){var x=(new _utc.default).setDomain([utcDate(2011,0,1,12,3,27),utcDate(2011,0,1,12,21,12)]);expect(x.ticks(4)).toEqual([utcDate(2011,0,1,12,5),utcDate(2011,0,1,12,10),utcDate(2011,0,1,12,15),utcDate(2011,0,1,12,20)])}));it("scaleUtc.ticks(count) can generate 15-minute ticks",(function(){var x=(new _utc.default).setDomain([utcDate(2011,0,1,12,8,27),utcDate(2011,0,1,13,4,12)]);expect(x.ticks(4)).toEqual([utcDate(2011,0,1,12,15),utcDate(2011,0,1,12,30),utcDate(2011,0,1,12,45),utcDate(2011,0,1,13,0)])}));it("scaleUtc.ticks(count) can generate 30-minute ticks",(function(){var x=(new _utc.default).setDomain([utcDate(2011,0,1,12,28,27),utcDate(2011,0,1,14,4,12)]);expect(x.ticks(4)).toEqual([utcDate(2011,0,1,12,30),utcDate(2011,0,1,13,0),utcDate(2011,0,1,13,30),utcDate(2011,0,1,14,0)])}));it("scaleUtc.ticks(count) can generate 1-hour ticks",(function(){var x=(new _utc.default).setDomain([utcDate(2011,0,1,12,28,27),utcDate(2011,0,1,16,34,12)]);expect(x.ticks(4)).toEqual([utcDate(2011,0,1,13,0),utcDate(2011,0,1,14,0),utcDate(2011,0,1,15,0),utcDate(2011,0,1,16,0)])}));it("scaleUtc.ticks(count) can generate 3-hour ticks",(function(){var x=(new _utc.default).setDomain([utcDate(2011,0,1,14,28,27),utcDate(2011,0,2,1,34,12)]);expect(x.ticks(4)).toEqual([utcDate(2011,0,1,15,0),utcDate(2011,0,1,18,0),utcDate(2011,0,1,21,0),utcDate(2011,0,2,0,0)])}));it("scaleUtc.ticks(count) can generate 6-hour ticks",(function(){var x=(new _utc.default).setDomain([utcDate(2011,0,1,16,28,27),utcDate(2011,0,2,14,34,12)]);expect(x.ticks(4)).toEqual([utcDate(2011,0,1,18,0),utcDate(2011,0,2,0,0),utcDate(2011,0,2,6,0),utcDate(2011,0,2,12,0)])}));it("scaleUtc.ticks(count) can generate 12-hour ticks",(function(){var x=(new _utc.default).setDomain([utcDate(2011,0,1,16,28,27),utcDate(2011,0,3,21,34,12)]);expect(x.ticks(4)).toEqual([utcDate(2011,0,2,0,0),utcDate(2011,0,2,12,0),utcDate(2011,0,3,0,0),utcDate(2011,0,3,12,0)])}));it("scaleUtc.ticks(count) can generate 1-day ticks",(function(){var x=(new _utc.default).setDomain([utcDate(2011,0,1,16,28,27),utcDate(2011,0,5,21,34,12)]);expect(x.ticks(4)).toEqual([utcDate(2011,0,2,0,0),utcDate(2011,0,3,0,0),utcDate(2011,0,4,0,0),utcDate(2011,0,5,0,0)])}));it("scaleUtc.ticks(count) can generate 2-day ticks",(function(){var x=(new _utc.default).setDomain([utcDate(2011,0,2,16,28,27),utcDate(2011,0,9,21,34,12)]);expect(x.ticks(4)).toEqual([utcDate(2011,0,3,0,0),utcDate(2011,0,5,0,0),utcDate(2011,0,7,0,0),utcDate(2011,0,9,0,0)])}));it("scaleUtc.ticks(count) can generate 1-week ticks",(function(){var x=(new _utc.default).setDomain([utcDate(2011,0,1,16,28,27),utcDate(2011,0,23,21,34,12)]);expect(x.ticks(4)).toEqual([utcDate(2011,0,2,0,0),utcDate(2011,0,9,0,0),utcDate(2011,0,16,0,0),utcDate(2011,0,23,0,0)])}));it("scaleUtc.ticks(count) can generate 1-month ticks",(function(){var x=(new _utc.default).setDomain([utcDate(2011,0,18),utcDate(2011,4,2)]);expect(x.ticks(4)).toEqual([utcDate(2011,1,1,0,0),utcDate(2011,2,1,0,0),utcDate(2011,3,1,0,0),utcDate(2011,4,1,0,0)])}));it("scaleUtc.ticks(count) can generate 3-month ticks",(function(){var x=(new _utc.default).setDomain([utcDate(2010,11,18),utcDate(2011,10,2)]);expect(x.ticks(4)).toEqual([utcDate(2011,0,1,0,0),utcDate(2011,3,1,0,0),utcDate(2011,6,1,0,0),utcDate(2011,9,1,0,0)])}));it("scaleUtc.ticks(count) can generate 1-year ticks",(function(){var x=(new _utc.default).setDomain([utcDate(2010,11,18),utcDate(2014,2,2)]);expect(x.ticks(4)).toEqual([utcDate(2011,0,1,0,0),utcDate(2012,0,1,0,0),utcDate(2013,0,1,0,0),utcDate(2014,0,1,0,0)])}));it("scaleUtc.ticks(count) can generate multi-year ticks",(function(){var x=(new _utc.default).setDomain([utcDate(0,11,18),utcDate(2014,2,2)]);expect(x.ticks(6)).toEqual([utcDate(500,0,1,0,0),utcDate(1e3,0,1,0,0),utcDate(1500,0,1,0,0),utcDate(2e3,0,1,0,0)])}));it("scaleUtc.ticks(count) returns one tick for an empty domain",(function(){var x=(new _utc.default).setDomain([utcDate(2014,2,2),utcDate(2014,2,2)]);expect(x.ticks(6)).toEqual([utcDate(2014,2,2)])}))}));describe("should be able to format ticks",(function(){it("scaleUtc.tickFormat()(date) formats year on New Year's",(function(){var f=(new _utc.default).tickFormat();expect(f(utcDate(2011,0,1))).toBe("2011");expect(f(utcDate(2012,0,1))).toBe("2012");expect(f(utcDate(2013,0,1))).toBe("2013")}));it("scaleUtc.tickFormat()(date) formats month on the 1st of each month",(function(){var f=(new _utc.default).tickFormat();expect(f(utcDate(2011,1,1))).toBe("February");expect(f(utcDate(2011,2,1))).toBe("March");expect(f(utcDate(2011,3,1))).toBe("April")}));it("scaleUtc.tickFormat()(date) formats week on Sunday midnight",(function(){var f=(new _utc.default).tickFormat();expect(f(utcDate(2011,1,6))).toBe("Feb 06");expect(f(utcDate(2011,1,13))).toBe("Feb 13");expect(f(utcDate(2011,1,20))).toBe("Feb 20")}));it("scaleUtc.tickFormat()(date) formats date on midnight",(function(){var f=(new _utc.default).tickFormat();expect(f(utcDate(2011,1,2))).toBe("Wed 02");expect(f(utcDate(2011,1,3))).toBe("Thu 03");expect(f(utcDate(2011,1,4))).toBe("Fri 04")}));it("scaleUtc.tickFormat()(date) formats hour on minute zero",(function(){var f=(new _utc.default).tickFormat();expect(f(utcDate(2011,1,2,11))).toBe("11 AM");expect(f(utcDate(2011,1,2,12))).toBe("12 PM");expect(f(utcDate(2011,1,2,13))).toBe("01 PM")}));it("scaleUtc.tickFormat()(date) formats minute on second zero",(function(){var f=(new _utc.default).tickFormat();expect(f(utcDate(2011,1,2,11,59))).toBe("11:59");expect(f(utcDate(2011,1,2,12,1))).toBe("12:01");expect(f(utcDate(2011,1,2,12,2))).toBe("12:02")}));it("scaleUtc.tickFormat()(date) otherwise, formats second",(function(){var f=(new _utc.default).tickFormat();expect(f(utcDate(2011,1,2,12,1,9))).toBe(":09");expect(f(utcDate(2011,1,2,12,1,10))).toBe(":10");expect(f(utcDate(2011,1,2,12,1,11))).toBe(":11")}));it("scaleUtc.tickFormat(count, specifier) returns a time format for the specified specifier",(function(){var f=(new _utc.default).tickFormat("%c");expect(f(utcDate(2011,1,2,12))).toBe("2/2/2011, 12:00:00 PM")}))}))}));