"use strict";var _interopRequireDefault=require("@babel/runtime/helpers/interopRequireDefault");var _extends=require("@babel/runtime/helpers/extends");exports.__esModule=true;exports.default=exports.TimeConverter=void 0;var _timeFormatter=_interopRequireDefault(require("./time-formatter.js"));var _timeParser=_interopRequireWildcard(require("./time-parser.js"));var _week=require("../time-intervals/week.js");var _week2=require("../time-intervals/utc/week.js");var _hour=_interopRequireDefault(require("../time-intervals/hour.js"));var _day=_interopRequireDefault(require("../time-intervals/day.js"));var _year=_interopRequireDefault(require("../time-intervals/year.js"));var _day2=_interopRequireDefault(require("../time-intervals/utc/day.js"));var _year2=_interopRequireDefault(require("../time-intervals/utc/year.js"));var _enUS=_interopRequireDefault(require("./locales/en-US.js"));function _interopRequireWildcard(e,t){if("function"==typeof WeakMap)var r=new WeakMap,n=new WeakMap;return(_interopRequireWildcard=function _interopRequireWildcard(e,t){if(!t&&e&&e.__esModule)return e;var o,i,f=_extends({},null,{default:e});if(null===e||"object"!=typeof e&&"function"!=typeof e)return f;if(o=t?n:r){if(o.has(e))return o.get(e);o.set(e,f)}for(var _t in e)"default"!==_t&&{}.hasOwnProperty.call(e,_t)&&((i=(o=Object.defineProperty)&&Object.getOwnPropertyDescriptor(e,_t))&&(i.get||i.set)?o(f,_t,i):f[_t]=e[_t]);return f})(e,t)}var numberRe=/^\s*\d+/,quarterRe=/^\s*Q\d+/,percentRe=/^%/,requoteRe=/[\\^$*+?|[\]().{}]/g,pad=function pad(value,fill,width){var sign=value<0?"-":"",string=(sign?-value:value)+"",length=string.length,padStr=length<width?new Array(width-length+1).join(fill)+string:string;return sign+padStr},requote=function requote(s){return s.replace(requoteRe,"\\$&")},formatRe=function formatRe(names){return new RegExp("^(?:"+names.map(requote).join("|")+")","i")},formatLookup=function formatLookup(names){var map={},i=-1,n=names.length;while(++i<n){map[names[i].toLowerCase()]=i}return map},parseWeekdayNumberSunday=function parseWeekdayNumberSunday(d,string,i){var n=numberRe.exec(string.slice(i,i+1));return n?(d.w=+n[0],i+n[0].length):-1},parseWeekdayNumberMonday=function parseWeekdayNumberMonday(d,string,i){var n=numberRe.exec(string.slice(i,i+1));return n?(d.u=+n[0],i+n[0].length):-1},parseWeekNumberSunday=function parseWeekNumberSunday(d,string,i){var n=numberRe.exec(string.slice(i,i+2));return n?(d.U=+n[0],i+n[0].length):-1},parseWeekNumberISO=function parseWeekNumberISO(d,string,i){var n=numberRe.exec(string.slice(i,i+2));return n?(d.V=+n[0],i+n[0].length):-1},parseWeekNumberMonday=function parseWeekNumberMonday(d,string,i){var n=numberRe.exec(string.slice(i,i+2));return n?(d.W=+n[0],i+n[0].length):-1},parseQuarter=function parseQuarter(d,string,i){var n=quarterRe.exec(string.slice(i,i+2));return n?(d.m=(n[0][1]-1)*3,i+n[0].length):-1},parseFullYear=function parseFullYear(d,string,i){var n=numberRe.exec(string.slice(i,i+4));return n?(d.y=+n[0],i+n[0].length):-1},parseYear=function parseYear(d,string,i){var n=numberRe.exec(string.slice(i,i+2));return n?(d.y=+n[0]+(+n[0]>68?1900:2e3),i+n[0].length):-1},parseZone=function parseZone(d,string,i){var n=/^(Z)|([+-]\d\d)(?::?(\d\d))?/.exec(string.slice(i,i+6));return n?(d.Z=n[1]?0:-(n[2]+(n[3]||"00")),i+n[0].length):-1},parseMonthNumber=function parseMonthNumber(d,string,i){var n=numberRe.exec(string.slice(i,i+2));return n?(d.m=n[0]-1,i+n[0].length):-1},parseDayOfMonth=function parseDayOfMonth(d,string,i){var n=numberRe.exec(string.slice(i,i+2));return n?(d.d=+n[0],i+n[0].length):-1},parseDayOfYear=function parseDayOfYear(d,string,i){var n=numberRe.exec(string.slice(i,i+3));return n?(d.m=0,d.d=+n[0],i+n[0].length):-1},parseHour24=function parseHour24(d,string,i){var n=numberRe.exec(string.slice(i,i+2));return n?(d.H=+n[0],i+n[0].length):-1},parseMinutes=function parseMinutes(d,string,i){var n=numberRe.exec(string.slice(i,i+2));return n?(d.M=+n[0],i+n[0].length):-1},parseSeconds=function parseSeconds(d,string,i){var n=numberRe.exec(string.slice(i,i+2));return n?(d.S=+n[0],i+n[0].length):-1},parseMilliseconds=function parseMilliseconds(d,string,i){var n=numberRe.exec(string.slice(i,i+3));return n?(d.L=+n[0],i+n[0].length):-1},parseMicroseconds=function parseMicroseconds(d,string,i){var n=numberRe.exec(string.slice(i,i+6));return n?(d.L=Math.floor(n[0]/1e3),i+n[0].length):-1},parseLiteralPercent=function parseLiteralPercent(d,string,i){var n=percentRe.exec(string.slice(i,i+1));return n?i+n[0].length:-1},parseUnixTimestamp=function parseUnixTimestamp(d,string,i){var n=numberRe.exec(string.slice(i));return n?(d.Q=+n[0],i+n[0].length):-1},parseUnixTimestampSeconds=function parseUnixTimestampSeconds(d,string,i){var n=numberRe.exec(string.slice(i));return n?(d.Q=+n[0]*1e3,i+n[0].length):-1},formatDayOfMonth=function formatDayOfMonth(d,p){return pad(d.getDate(),p,2)},formatHour24=function formatHour24(d,p){return pad(d.getHours(),p,2)},formatHour12=function formatHour12(d,p){return pad(d.getHours()%12||12,p,2)},formatDayOfYear=function formatDayOfYear(d,p){return pad(1+_day.default.count(_year.default.floor(d),d),p,3)},formatMilliseconds=function formatMilliseconds(d,p){return pad(d.getMilliseconds(),p,3)},formatMicroseconds=function formatMicroseconds(d,p){return formatMilliseconds(d,p)+"000"},formatMonthNumber=function formatMonthNumber(d,p){return pad(d.getMonth()+1,p,2)},formatMinutes=function formatMinutes(d,p){return pad(d.getMinutes(),p,2)},formatSeconds=function formatSeconds(d,p){return pad(d.getSeconds(),p,2)},formatQuarter=function formatQuarter(d,p){return"Q"+Math.ceil((d.getMonth()+1)/3)},formatWeekdayNumberMonday=function formatWeekdayNumberMonday(d){var day=d.getDay();return day===0?7:day},formatWeekNumberSunday=function formatWeekNumberSunday(d,p){return pad(_week.sunday.count(_year.default.floor(d),d),p,2)},formatWeekNumberISO=function formatWeekNumberISO(_d,p){var d=_d,day=d.getDay();d=day>=4||day===0?_week.thursday.floor(d):_week.thursday.ceil(d);return pad(_week.thursday.count(_year.default.floor(d),d)+(_year.default.floor(d).getDay()===4),p,2)},formatWeekdayNumberSunday=function formatWeekdayNumberSunday(d){return d.getDay()},formatWeekNumberMonday=function formatWeekNumberMonday(d,p){return pad(_week.monday.count(_year.default.floor(d),d),p,2)},formatYear=function formatYear(d,p){return pad(d.getFullYear()%100,p,2)},formatFullYear=function formatFullYear(d,p){return pad(d.getFullYear()%1e4,p,4)},formatZone=function formatZone(d){var z=d.getTimezoneOffset();return(z>0?"-":(z*=-1,"+"))+pad(z/60|0,"0",2)+pad(z%60,"0",2)},formatUTCDayOfMonth=function formatUTCDayOfMonth(d,p){return pad(d.getUTCDate(),p,2)},formatUTCHour24=function formatUTCHour24(d,p){return pad(d.getUTCHours(),p,2)},formatUTCHour12=function formatUTCHour12(d,p){return pad(d.getUTCHours()%12||12,p,2)},formatUTCDayOfYear=function formatUTCDayOfYear(d,p){return pad(1+_day2.default.count(_year2.default.floor(d),d),p,3)},formatUTCMilliseconds=function formatUTCMilliseconds(d,p){return pad(d.getUTCMilliseconds(),p,3)},formatUTCMicroseconds=function formatUTCMicroseconds(d,p){return formatUTCMilliseconds(d,p)+"000"},formatUTCMonthNumber=function formatUTCMonthNumber(d,p){return pad(d.getUTCMonth()+1,p,2)},formatUTCMinutes=function formatUTCMinutes(d,p){return pad(d.getUTCMinutes(),p,2)},formatUTCSeconds=function formatUTCSeconds(d,p){return pad(d.getUTCSeconds(),p,2)},formatUTCQuarter=function formatUTCQuarter(d,p){return"Q"+Math.ceil((d.getUTCMonth()+1)/3)},formatUTCWeekdayNumberMonday=function formatUTCWeekdayNumberMonday(d){var dow=d.getUTCDay();return dow===0?7:dow},formatUTCWeekNumberSunday=function formatUTCWeekNumberSunday(d,p){return pad(_week2.utcSunday.count(_year2.default.floor(d),d),p,2)},formatUTCWeekNumberISO=function formatUTCWeekNumberISO(_d,p){var d=_d,day=d.getUTCDay();d=day>=4||day===0?_week2.utcThursday.floor(d):_week2.utcThursday.ceil(d);return pad(_week2.utcThursday.count(_year2.default.floor(d),d)+(_year2.default.floor(d).getUTCDay()===4),p,2)},formatUTCWeekdayNumberSunday=function formatUTCWeekdayNumberSunday(d){return d.getUTCDay()},formatUTCWeekNumberMonday=function formatUTCWeekNumberMonday(d,p){return pad(_week2.utcMonday.count(_year2.default.floor(d),d),p,2)},formatUTCYear=function formatUTCYear(d,p){return pad(d.getUTCFullYear()%100,p,2)},formatUTCFullYear=function formatUTCFullYear(d,p){return pad(d.getUTCFullYear()%1e4,p,4)},formatUTCZone=function formatUTCZone(){return"+0000"},formatLiteralPercent=function formatLiteralPercent(){return"%"},formatUnixTimestamp=function formatUnixTimestamp(d){return+d},formatUnixTimestampSeconds=function formatUnixTimestampSeconds(d){return Math.floor(+d/1e3)};var TimeConverter=exports.TimeConverter=function(){function TimeConverter(locale){var _this=this;var localeDateTime=locale.dateTime,localeDate=locale.date,localeTime=locale.time,localePeriods=locale.periods,localeWeekdays=locale.days,localeShortWeekdays=locale.shortDays,localeMonths=locale.months,localeShortMonths=locale.shortMonths,periodRe=formatRe(localePeriods),periodLookup=formatLookup(localePeriods),weekdayRe=formatRe(localeWeekdays),weekdayLookup=formatLookup(localeWeekdays),shortWeekdayRe=formatRe(localeShortWeekdays),shortWeekdayLookup=formatLookup(localeShortWeekdays),monthRe=formatRe(localeMonths),monthLookup=formatLookup(localeMonths),shortMonthRe=formatRe(localeShortMonths),shortMonthLookup=formatLookup(localeShortMonths);this._formats={a:function a(d){return localeShortWeekdays[d.getDay()]},A:function A(d){return localeWeekdays[d.getDay()]},b:function b(d){return localeShortMonths[d.getMonth()]},B:function B(d){return localeMonths[d.getMonth()]},d:formatDayOfMonth,e:formatDayOfMonth,f:formatMicroseconds,H:formatHour24,I:formatHour12,j:formatDayOfYear,L:formatMilliseconds,m:formatMonthNumber,M:formatMinutes,p:function p(d){return localePeriods[+(d.getHours()>=12)]},q:formatQuarter,Q:formatUnixTimestamp,s:formatUnixTimestampSeconds,S:formatSeconds,u:formatWeekdayNumberMonday,U:formatWeekNumberSunday,V:formatWeekNumberISO,w:formatWeekdayNumberSunday,W:formatWeekNumberMonday,y:formatYear,Y:formatFullYear,Z:formatZone,"%":formatLiteralPercent};this._utcFormats={a:function a(d){return localeShortWeekdays[d.getUTCDay()]},A:function A(d){return localeWeekdays[d.getUTCDay()]},b:function b(d){return localeShortMonths[d.getUTCMonth()]},B:function B(d){return localeMonths[d.getUTCMonth()]},d:formatUTCDayOfMonth,e:formatUTCDayOfMonth,f:formatUTCMicroseconds,H:formatUTCHour24,I:formatUTCHour12,j:formatUTCDayOfYear,L:formatUTCMilliseconds,m:formatUTCMonthNumber,M:formatUTCMinutes,p:function p(d){return localePeriods[+(d.getUTCHours()>=12)]},q:formatUTCQuarter,Q:formatUnixTimestamp,s:formatUnixTimestampSeconds,S:formatUTCSeconds,u:formatUTCWeekdayNumberMonday,U:formatUTCWeekNumberSunday,V:formatUTCWeekNumberISO,w:formatUTCWeekdayNumberSunday,W:formatUTCWeekNumberMonday,y:formatUTCYear,Y:formatUTCFullYear,Z:formatUTCZone,"%":formatLiteralPercent};this._parses={a:function a(d,string,i){var n=shortWeekdayRe.exec(string.slice(i));if(n){d.w=shortWeekdayLookup[n[0].toLowerCase()];return i+n[0].length}return-1},A:function A(d,string,i){var n=weekdayRe.exec(string.slice(i));if(n){d.w=weekdayLookup[n[0].toLowerCase()];return i+n[0].length}return-1},b:function b(d,string,i){var n=shortMonthRe.exec(string.slice(i));if(n){d.m=shortMonthLookup[n[0].toLowerCase()];return i+n[0].length}return-1},B:function B(d,string,i){var n=monthRe.exec(string.slice(i));if(n){d.m=monthLookup[n[0].toLowerCase()];return i+n[0].length}return-1},c:null,d:parseDayOfMonth,e:parseDayOfMonth,f:parseMicroseconds,H:parseHour24,I:parseHour24,j:parseDayOfYear,L:parseMilliseconds,m:parseMonthNumber,M:parseMinutes,p:function p(d,string,i){var n=periodRe.exec(string.slice(i));if(n){d.p=periodLookup[n[0].toLowerCase()];return i+n[0].length}return-1},Q:parseUnixTimestamp,q:parseQuarter,s:parseUnixTimestampSeconds,S:parseSeconds,u:parseWeekdayNumberMonday,U:parseWeekNumberSunday,V:parseWeekNumberISO,w:parseWeekdayNumberSunday,W:parseWeekNumberMonday,x:null,X:null,y:parseYear,Y:parseFullYear,Z:parseZone,"%":parseLiteralPercent};this._formats.x=function(d){return new _timeFormatter.default(localeDate,_this._formats).format(d)};this._formats.X=function(d){return new _timeFormatter.default(localeTime,_this._formats).format(d)};this._formats.c=function(d){return new _timeFormatter.default(localeDateTime,_this._formats).format(d)};this._utcFormats.x=function(d){return new _timeFormatter.default(localeDate,_this._utcFormats).format(d)};this._utcFormats.X=function(d){return new _timeFormatter.default(localeTime,_this._utcFormats).format(d)};this._utcFormats.c=function(d){return new _timeFormatter.default(localeDateTime,_this._utcFormats).format(d)};this._parses.c=function(d,string,i){return new _timeParser.default(localeDateTime,_this._parses).parseSpecifier(d,string,i)};this._parses.x=function(d,string,i){return new _timeParser.default(localeDate,_this._parses).parseSpecifier(d,string,i)};this._parses.X=function(d,string,i){return new _timeParser.default(localeTime,_this._parses).parseSpecifier(d,string,i)}}var _proto=TimeConverter.prototype;_proto.formatter=function formatter(specifier){if(specifier===void 0){specifier=""}return new _timeFormatter.default(specifier.toString(),this._formats)};_proto.utcFormatter=function utcFormatter(specifier){if(specifier===void 0){specifier=""}return new _timeFormatter.default(specifier.toString(),this._utcFormats)};_proto.parser=function parser(_specifier){var specifier=_specifier;return new _timeParser.default(specifier+="",this._parses,(function(d){var date;if(d.y>=0&&d.y<100){date=new Date(-1,d.m,d.d,d.H,d.M,d.S,d.L);date.setFullYear(d.y);return date}date=new Date(d.y,d.m,d.d,d.H,d.M,d.S,d.L);var winterOffset=new Date(d.y,0).getTimezoneOffset(),summerOffset=new Date(d.y,6).getTimezoneOffset(),dateOffset=new Date(d.y,d.m,d.d,d.H,d.M,d.S,d.L).getTimezoneOffset();if(summerOffset===winterOffset){return date}if(winterOffset>summerOffset&&winterOffset!==dateOffset){date=_hour.default.offset(date,1)}return date}))};_proto.utcParser=function utcParser(_specifier){var specifier=_specifier;return new _timeParser.default(specifier+="",this._parses,_timeParser.utcDate)};return TimeConverter}();var _default=exports.default=new TimeConverter(_enUS.default);