"use strict";var _interopRequireDefault=require("@babel/runtime/helpers/interopRequireDefault");var _extends=require("@babel/runtime/helpers/extends");exports.__esModule=true;exports.dateIntervalToString=dateIntervalToString;exports.dateRangeCaclulator=dateRangeCaclulator;exports.getDateOffset=getDateOffset;exports.getDateStart=getDateStart;exports.getDefaultOutputFormat=getDefaultOutputFormat;var timeIntervals=_interopRequireWildcard(require("../time-intervals"));var timeIntervalsUTC=_interopRequireWildcard(require("../time-intervals/utc"));var _datetimeEnums=require("../datetime-enums");var _timeConverter=_interopRequireDefault(require("../time-converter"));function _interopRequireWildcard(e,t){if("function"==typeof WeakMap)var r=new WeakMap,n=new WeakMap;return(_interopRequireWildcard=function _interopRequireWildcard(e,t){if(!t&&e&&e.__esModule)return e;var o,i,f=_extends({},null,{default:e});if(null===e||"object"!=typeof e&&"function"!=typeof e)return f;if(o=t?n:r){if(o.has(e))return o.get(e);o.set(e,f)}for(var _t in e)"default"!==_t&&{}.hasOwnProperty.call(e,_t)&&((i=(o=Object.defineProperty)&&Object.getOwnPropertyDescriptor(e,_t))&&(i.get||i.set)?o(f,_t,i):f[_t]=e[_t]);return f})(e,t)}var unitDefaultFormats={Year:"%Y",Month:"%b %Y",Day:"%b %d, %Y",Hour:"%b %d, %Y %H hrs",Minute:"%b %d, %Y %H:%M",Second:"%b %d, %Y %H:%M:%S",Millisecond:"%b %d, %Y %H:%M:%S:%L"},timeIntervalMapping={Millisecond:timeIntervals.timeMillisecond,Second:timeIntervals.timeSecond,Minute:timeIntervals.timeMinute,Hour:timeIntervals.timeHour,Day:timeIntervals.timeDay,Week:{0:timeIntervals.timeSunday,1:timeIntervals.timeMonday,2:timeIntervals.timeTuesday,3:timeIntervals.timeWednesday,4:timeIntervals.timeThursday,5:timeIntervals.timeFriday,6:timeIntervals.timeSaturday},Month:timeIntervals.timeMonth,Quarter:timeIntervals.timeQuarter,Year:timeIntervals.timeYear},UTCTimeIntervalMapping={Millisecond:timeIntervalsUTC.utcMillisecond,Second:timeIntervalsUTC.utcSecond,Minute:timeIntervalsUTC.utcMinute,Hour:timeIntervalsUTC.utcHour,Day:timeIntervalsUTC.utcDay,Week:{0:timeIntervalsUTC.utcSunday,1:timeIntervalsUTC.utcMonday,2:timeIntervalsUTC.utcTuesday,3:timeIntervalsUTC.utcWednesday,4:timeIntervalsUTC.utcThursday,5:timeIntervalsUTC.utcFriday,6:timeIntervalsUTC.utcSaturday},Month:timeIntervalsUTC.utcMonth,Quarter:timeIntervalsUTC.utcQuarter,Year:timeIntervalsUTC.utcYear};function getDefaultOutputFormat(Unit){switch(Unit){case"Millisecond":case"Second":case"Minute":case"Hour":case"Day":case"Month":case"Year":return unitDefaultFormats[Unit];case"Week":return unitDefaultFormats.Day;case"Quarter":return unitDefaultFormats.Month}}function dateIntervalToString(){var specifier,config=this.config;specifier=(typeof config.enableUTC!=="undefined"?config.enableUTC:false)?_timeConverter.default.utcFormatter(config.outputFormat):_timeConverter.default.formatter(config.outputFormat);switch(config.duration.Unit){case"Millisecond":case"Second":case"Minute":case"Hour":case"Day":case"Month":case"Year":return specifier.format(new Date(this.start))+(config.duration.number>1?" - "+specifier.format(new Date(this.end-1)):"");case"Week":case"Quarter":return specifier.format(new Date(this.start))+" - "+specifier.format(new Date(this.end-1))}}function dateRangeCaclulator(start,duration,enableUTC,weekStartFrom,calculateStart){if(calculateStart===void 0){calculateStart=false}var startDate,endDate,durationCopy;startDate=start;if(calculateStart){durationCopy=Object.assign({},duration);durationCopy.number=1;startDate=getDateStart(startDate,durationCopy,enableUTC,weekStartFrom)}endDate=getDateOffset(startDate,duration.Unit,duration.number,enableUTC,weekStartFrom);return{startDate:startDate,endDate:endDate}}function getDateStart(date,duration,enableUTC,_weekStartFrom,start){var timeIntervalObj=(typeof enableUTC!=="undefined"?enableUTC:false)?UTCTimeIntervalMapping[duration.Unit]:timeIntervalMapping[duration.Unit],weekStartFrom=_weekStartFrom;if(weekStartFrom&&!_datetimeEnums.Weekdays[weekStartFrom.name])throw new Error("Invalid weekStartFrom provided: "+weekStartFrom);if(duration.number===1){if(duration.Unit==="Week"){weekStartFrom=weekStartFrom||_datetimeEnums.Weekdays.Sunday;return+timeIntervalObj[weekStartFrom.id].floor(new Date(date))}return+timeIntervalObj.floor(new Date(date))}else if(!start){if(duration.Unit==="Week"){weekStartFrom=weekStartFrom||_datetimeEnums.Weekdays.Sunday;return+timeIntervalObj[weekStartFrom.id].every(duration.number).floor(new Date(date))}return+timeIntervalObj.every(duration.number).floor(new Date(date))}var count,extraUnit;if(duration.Unit==="Week"){weekStartFrom=weekStartFrom||_datetimeEnums.Weekdays.Sunday;count=timeIntervalObj[weekStartFrom.id].count(start,date);extraUnit=count%duration.number;if(extraUnit){return getDateOffset(+timeIntervalObj[weekStartFrom.id].floor(date),duration.Unit,-extraUnit,enableUTC,weekStartFrom)}return+timeIntervalObj[weekStartFrom.id].floor(date)}count=timeIntervalObj.count(start,date);extraUnit=count%duration.number;if(extraUnit){return getDateOffset(+timeIntervalObj.floor(date),duration.Unit,-extraUnit,enableUTC,weekStartFrom)}return+timeIntervalObj.floor(date)}function getDateOffset(date,unit,offset,enableUTC,weekStartFrom){switch(unit){case"Month":case"Quarter":case"Year":var timeIntervalObj=(typeof enableUTC!=="undefined"?enableUTC:false)?UTCTimeIntervalMapping[unit]:timeIntervalMapping[unit];return+timeIntervalObj.offset(new Date(date),offset);default:return date+_datetimeEnums.DatetimeUnits[unit].ms*offset}}